package com.flow.common.core.util;

import lombok.Getter;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.annotation.Configuration;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author caixiaofeng
 * @version 1.0
 * @Description: <<>>
 * @company 无名人
 * @create 2021-04-16 14:58
 */
@Configuration
public class ApplicationContextUtil implements ApplicationContextAware {
    @Getter
    private static ApplicationContext applicationContext;

    @Override
    public void setApplicationContext(ApplicationContext context) throws BeansException {
        ApplicationContextUtil.applicationContext = context;
    }

    public static <T> T getBean(Class<T> beanName) {
        return applicationContext.getBean(beanName);
    }

    public static <T> List<T> getBeansOfType(Class<T> clazz) {
        Map map;
        try {
            map = applicationContext.getBeansOfType(clazz);
        } catch (Exception var3) {
            map = null;
        }
        return map == null ? null : new ArrayList(map.values());
    }

    public static <T> Map<String, T> getBeans(Class<T> beanName){
        return applicationContext.getBeansOfType(beanName);
    }

    public static Object getBean(String beanName) {
        return applicationContext.getBean(beanName);
    }

}
