package com.flow.flowable.behavior;

import com.flow.flowable.cmd.CopyProcessInstanceCmd;
import com.flow.flowable.model.CopyServiceTask;
import org.flowable.bpmn.model.MultiInstanceLoopCharacteristics;
import org.flowable.engine.ManagementService;
import org.flowable.engine.delegate.DelegateExecution;
import org.flowable.engine.impl.bpmn.behavior.AbstractBpmnActivityBehavior;
import org.flowable.engine.impl.persistence.entity.ActivityInstanceEntity;
import org.flowable.engine.impl.persistence.entity.ActivityInstanceEntityManager;
import org.flowable.engine.impl.persistence.entity.HistoricActivityInstanceEntity;
import org.flowable.engine.impl.persistence.entity.HistoricActivityInstanceEntityManager;
import org.flowable.engine.impl.util.CommandContextUtil;

import java.util.List;

public class CopyActivityBehavior extends AbstractBpmnActivityBehavior {

    @Override
    public void execute(DelegateExecution execution) {
        CopyServiceTask copyServiceTask = (CopyServiceTask) execution.getCurrentFlowElement();
        MultiInstanceLoopCharacteristics loopCharacteristics = copyServiceTask.getLoopCharacteristics();
        String elementVariable = loopCharacteristics.getElementVariable();
        String assignee = execution.getVariableLocal(elementVariable, String.class);
        ActivityInstanceEntityManager activityInstanceEntityManager = CommandContextUtil.getActivityInstanceEntityManager();
        List<ActivityInstanceEntity> activityInstanceEntities = activityInstanceEntityManager.findActivityInstancesByExecutionAndActivityId(execution.getId(), execution.getCurrentActivityId());
        for (ActivityInstanceEntity activityInstanceEntity : activityInstanceEntities) {
            activityInstanceEntity.setAssignee(assignee);
            activityInstanceEntityManager.update(activityInstanceEntity);
        }
        HistoricActivityInstanceEntityManager historicActivityInstanceEntityManager = CommandContextUtil.getHistoricActivityInstanceEntityManager();
        List<HistoricActivityInstanceEntity> historicActivityInstanceEntities = historicActivityInstanceEntityManager.findHistoricActivityInstancesByExecutionAndActivityId(execution.getId(), execution.getCurrentActivityId());
        for (HistoricActivityInstanceEntity historicActivityInstanceEntity : historicActivityInstanceEntities) {
            historicActivityInstanceEntity.setAssignee(assignee);
            historicActivityInstanceEntityManager.update(historicActivityInstanceEntity);
        }
        ManagementService managementService = CommandContextUtil.getProcessEngineConfiguration().getManagementService();
        managementService.executeCommand(new CopyProcessInstanceCmd(execution.getProcessInstanceId(), assignee));
        leave(execution);
    }
}
