package com.flow.flowable.cmd;

import org.flowable.bpmn.model.Activity;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.bpmn.model.MultiInstanceLoopCharacteristics;
import org.flowable.common.engine.api.FlowableException;
import org.flowable.common.engine.impl.interceptor.Command;
import org.flowable.common.engine.impl.interceptor.CommandContext;
import org.flowable.engine.impl.persistence.entity.ExecutionEntity;
import org.flowable.engine.impl.persistence.entity.ExecutionEntityManager;
import org.flowable.engine.impl.util.CommandContextUtil;
import org.flowable.engine.impl.util.ProcessDefinitionUtil;

import java.util.Objects;

public class GetLoopCharacteristicsCmd implements Command<MultiInstanceLoopCharacteristics> {
    protected String processInstanceId;
    protected String taskDefinitionKey;

    public GetLoopCharacteristicsCmd(String processInstanceId, String taskDefinitionKey) {
        this.processInstanceId = processInstanceId;
        this.taskDefinitionKey = taskDefinitionKey;
    }

    @Override
    public MultiInstanceLoopCharacteristics execute(CommandContext commandContext) {
        ExecutionEntityManager executionManager = CommandContextUtil.getExecutionEntityManager(commandContext);
        ExecutionEntity processInstance = executionManager.findById(processInstanceId);
        if (Objects.isNull(processInstance)) {
            throw new FlowableException("流程不存在");
        }
        BpmnModel bpmnModel = ProcessDefinitionUtil.getBpmnModel(processInstance.getProcessDefinitionId());
        FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
        if (flowElement instanceof Activity) {
            return ((Activity) flowElement).getLoopCharacteristics();

        }
        return null;
    }
}
