package com.flow;

import com.flow.common.core.model.Result;
import com.flow.entity.StorageFile;
import com.flow.service.FileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Set;

@RestController
@RequestMapping("/file")
public class FileController {
    @Autowired
    private FileService fileService;

    @PostMapping("/upload")
    public Result<StorageFile> upload(@RequestParam MultipartFile file) throws IOException {
        return Result.success(fileService.upload(file));
    }

    // 删除文件
    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        fileService.delete(ids);
        return Result.success();
    }
}
