package com.flow.service.impl;

import com.flow.entity.MessageEntity;
import com.flow.entity.Notify;
import com.flow.service.NotificationStrategy;
import com.flow.service.NotifyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
public class InAppNotificationStrategy implements NotificationStrategy {
    @Autowired
    private SimpMessagingTemplate messagingTemplate;
    @Autowired
    private NotifyService notifyService;

    @Override
    public void send(String receiver, String subject, String content) {
        Notify notify = new Notify();
        notify.setReceiver(receiver);
        notify.setSubject(subject);
        notify.setContent(content);
        notify.setReceivingTime(LocalDateTime.now());
        notify.setSender("admin");
        boolean save = notifyService.save(notify);
        if (save) {
            MessageEntity<Notify> messageEntity = new MessageEntity<>(
                    notify.getSender(),
                    notify.getReceiver(),
                    notify
            );
            messagingTemplate.convertAndSendToUser(notify.getReceiver(), "/topic/notify", messageEntity);
        }
    }

    @Override
    public String getType() {
        return "in_app";
    }
}
