package com.flow.controller;

import com.flow.common.core.model.CursorResult;
import com.flow.common.core.model.PageResult;
import com.flow.common.core.model.Result;
import com.flow.entity.Notify;
import com.flow.model.NotifyQuery;
import com.flow.service.NotifyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.messaging.simp.SimpMessageSendingOperations;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/notify")
public class NotifyController {
    @Autowired
    private NotifyService notifyService;
    @Autowired
    private SimpMessageSendingOperations simpMessageSendingOperations;

    @GetMapping("/unread")
    public Result<Long> getUnreadCount() {
        return Result.success(notifyService.getUnreadCount());
    }

    @GetMapping
    public Result<PageResult<Notify>> getList(NotifyQuery notifyQuery) {
        return Result.success(notifyService.getList(notifyQuery));
    }

    @GetMapping("/cursor")
    public Result<CursorResult<Notify>> cursor(NotifyQuery notifyQuery) {
        return Result.success(notifyService.cursor(notifyQuery));
    }

    @PutMapping("/read")
    public Result<?> read(@RequestBody List<Long> ids) {
        notifyService.read(ids);
        return Result.success();
    }

    @PutMapping("/readAll")
    public Result<?> readAll() {
        notifyService.readAll();
        return Result.success();
    }

    @DeleteMapping
    public Result<?> delete(@RequestBody List<Long> ids) {
        notifyService.delete(ids);
        return Result.success();
    }

}
