package com.flow.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public enum NotifyEnum {
    SYSTEM("system", "系统通知"),
    TODO("todo", "待办"),
    MESSAGE("message", "消息");

    @EnumValue
    @JsonValue
    private final String type;
    private final String desc;

    public static NotifyEnum match(String type) {
        for (NotifyEnum value : NotifyEnum.values()) {
            if (value.type.equals(type)) {
                return value;
            }
        }
        return null;
    }
}
