package com.flow.dao;

import com.flow.entity.Menu;
import com.flow.entity.Role;
import com.flow.entity.User;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Set;

public interface AuthDao {

    @Select("SELECT permission FROM sys_menu where type = 2 and permission is not null")
    Set<String> getPermissionAll();



    @Select({
            "<script>",
            "SELECT permission FROM sys_menu where type = 2 and id in (select menu_id from sys_role_menu where role_id in ",
            "<foreach item='roleId' collection='roleIds' open='(' separator=',' close=')'>",
            "#{roleId}",
            "</foreach>)",
            "</script>"
    })
    Set<String> queryPermissionsByRoleIds(Set<Long> roleIds);

    @Select("select * from sys_role")
    Set<Role> getRoleAll();

    @Select("select * from sys_role where id in (select role_id from sys_user_role where user_id = #{userId})")
    Set<Role> queryRoleByUserId(String userId);

    @Result(column = "keep_alive", property = "cache", javaType = Boolean.class)
    @Select("select * from sys_menu")
    List<Menu> getMenuAll();

    @Result(column = "keep_alive", property = "cache", javaType = Boolean.class)
    @Select("select * from sys_menu where id in (select menu_id from sys_role_menu where role_id in (select role_id from sys_user_role where user_id = #{userId}))")
    List<Menu> getMenuByUserId(String userId);

    @Select("select * from sys_user where username = #{userId}")
    User queryUserByUserId(String userId);

}
