package com.flow.controller;

import com.flow.common.core.model.Result;
import com.flow.entity.User;
import com.flow.model.AccessToken;
import com.flow.model.ImageCode;
import com.flow.model.LoginForm;
import com.flow.model.Permission;
import com.flow.service.AuthService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/auth")
public class AuthController {
    @Autowired
    private AuthService authService;

    @GetMapping("/code")
    public Result<ImageCode> getImageCode() {
        return Result.success(authService.getImageCode());
    }

    @PostMapping("/login")
    public Result<AccessToken> login(@RequestBody LoginForm loginForm) {
        return Result.success(authService.login(loginForm));
    }

    @PostMapping("/logout")
    public Result<?> logout() {
        authService.logout();
        return Result.success();
    }

    @GetMapping("/info")
    public Result<User> info() {
        return Result.success(authService.info());
    }

    @GetMapping("/permissions")
    public Result<Permission> permissions() {
        return Result.success(authService.permissions());
    }

}
