package com.flow.model;

import lombok.Data;
import org.springframework.security.oauth2.common.OAuth2AccessToken;

import java.util.Set;

@Data
public class AccessToken {
    public AccessToken(OAuth2AccessToken oAuth2AccessToken) {
        this.tokenType = oAuth2AccessToken.getTokenType();
        this.accessToken = String.format("Bearer %s", oAuth2AccessToken.getValue());
        this.refreshToken = oAuth2AccessToken.getRefreshToken().getValue();
        this.expiresIn = oAuth2AccessToken.getExpiresIn();
        this.scope = oAuth2AccessToken.getScope();
    }

    private String tokenType;
    private String accessToken;
    private String refreshToken;
    private Integer expiresIn;
    private Set<String> scope;
}
