package com.flow.model;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.flow.entity.Menu;
import lombok.Data;

import java.util.List;


@Data
public class Route {
    private String name;
    private String path;
    private String component;
    private String redirect;
    private Meta meta;
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<Route> children;

    public Route(Menu menu) {
        this.name = menu.getName();
        this.path = menu.getPath();
        this.component = menu.getComponent();
        this.redirect = menu.getRedirect();
        Meta meta = new Meta();
        meta.setTitle(menu.getTitle());
        meta.setIcon(menu.getIcon());
        meta.setCache(menu.getCache());
        //meta.setLink(menu.getLink());
        meta.setHidden(menu.getHidden());
        //meta.setFull(menu.getFull());
        meta.setAffix(menu.getAffix());
        meta.setActiveMenu(menu.getActiveMenu());
        this.meta = meta;

    }
}
