package com.flow.service.impl;

import com.flow.common.mybatis.service.impl.BaseServiceImpl;
import com.flow.dao.ReportDatasetDao;
import com.flow.entity.ReportDataset;
import com.flow.service.ReportDatasetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

@Service
public class ReportDatasetServiceImpl extends BaseServiceImpl<ReportDatasetDao, ReportDataset> implements ReportDatasetService {
    @Autowired
    private ReportDatasetDao reportDatasetDao;

    @Override
    public ReportDataset create(ReportDataset reportDataset) {
        reportDatasetDao.insert(reportDataset);
        return reportDataset;
    }

    @Override
    public ReportDataset update(ReportDataset reportDataset) {
        reportDatasetDao.updateById(reportDataset);
        return reportDataset;
    }

    @Override
    public void delete(Set<Long> ids) {
        reportDatasetDao.deleteBatchIds(ids);
    }

    @Override
    public List<ReportDataset> getList(String templateId) {
        return reportDatasetDao.lambdaQueryChain()
                .eq(ReportDataset::getTemplateId, templateId)
                .list();
    }
}
