package com.flow.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.flow.common.core.model.PageResult;
import com.flow.common.mybatis.service.impl.BaseServiceImpl;
import com.flow.dao.ReportTemplateDao;
import com.flow.entity.ReportTemplate;
import com.flow.mapstruct.ReportTemplateMapper;
import com.flow.model.ReportTemplateQuery;
import com.flow.service.ReportTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Optional;
import java.util.Set;

@Service
public class ReportTemplateServiceImpl extends BaseServiceImpl<ReportTemplateDao, ReportTemplate> implements ReportTemplateService {
    @Autowired
    private ReportTemplateDao reportTemplateDao;
    @Autowired
    private ReportTemplateMapper reportTemplateMapper;


    @Override
    public PageResult<ReportTemplate> getList(ReportTemplateQuery reportTemplateQuery) {
        ReportTemplate reportTemplate = reportTemplateMapper.toEntity(reportTemplateQuery);
        Page<ReportTemplate> page = reportTemplateDao.lambdaQueryChain()
                .select(ReportTemplate.class, i -> !i.getColumn().equals("data"))
                .page(
                        new Page<>(reportTemplateQuery.getPage(), reportTemplateQuery.getLimit())
                );
        return new PageResult<>(page.getTotal(), page.getRecords());
    }

    @Override
    public ReportTemplate getTemplate(String id) {
        Optional<ReportTemplate> optional = reportTemplateDao.lambdaQueryChain()
                .eq(ReportTemplate::getId, id)
                .oneOpt();
        return optional.orElse(null);
    }

    @Override
    public ReportTemplate create(ReportTemplate reportTemplate) {
        reportTemplateDao.insert(reportTemplate);
        return reportTemplate;
    }

    @Override
    public ReportTemplate update(ReportTemplate reportTemplate) {
        reportTemplateDao.updateById(reportTemplate);
        return reportTemplate;
    }

    @Override
    public void delete(Set<Long> ids) {
        reportTemplateDao.deleteBatchIds(ids);
    }
}
