package com.flow.controller;

import com.flow.common.core.model.Result;
import com.flow.entity.ReportDataset;
import com.flow.service.ReportDatasetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Set;

@RestController
@RequestMapping("/reportDataset")
public class ReportDatasetController {
    @Autowired
    private ReportDatasetService reportDatasetService;

    @PostMapping
    public Result<ReportDataset> create(@RequestBody ReportDataset reportDataset) {
        return Result.success(reportDatasetService.create(reportDataset));
    }

    @PutMapping
    public Result<ReportDataset> update(@RequestBody ReportDataset reportDataset) {
        return Result.success(reportDatasetService.update(reportDataset));
    }

    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        reportDatasetService.delete(ids);
        return Result.success();
    }

    @GetMapping("/{templateId}")
    public Result<List<ReportDataset>> getList(@PathVariable String templateId) {
        return Result.success(reportDatasetService.getList(templateId));
    }

}
