package com.flow.controller;

import com.flow.common.core.model.PageResult;
import com.flow.common.core.model.Result;
import com.flow.entity.ReportDataSource;
import com.flow.model.ExecSql;
import com.flow.model.ReportDatasourceQuery;
import com.flow.service.ReportDatasourceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Set;

@RestController
@RequestMapping("/reportDatasource")
public class ReportDatasourceController {
    @Autowired
    private ReportDatasourceService reportDatasourceService;

    @GetMapping
    public Result<PageResult<ReportDataSource>> getList(ReportDatasourceQuery reportDatasourceQuery) {
        PageResult<ReportDataSource> list = reportDatasourceService.getList(reportDatasourceQuery);
        return Result.success(list);
    }

    // @PreAuthorize("hasAnyAuthority('reportDatasource:add')")
    @PostMapping
    public Result<ReportDataSource> create(@RequestBody ReportDataSource reportDataSource) {
        return Result.success(reportDatasourceService.create(reportDataSource));
    }

    // @PreAuthorize("hasAnyAuthority('reportDatasource:edit')")
    @PutMapping
    public Result<ReportDataSource> update(@RequestBody ReportDataSource reportDataSource) {
        return Result.success(reportDatasourceService.update(reportDataSource));
    }

    // @PreAuthorize("hasAnyAuthority('reportDatasource:del')")
    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        reportDatasourceService.delete(ids);
        return Result.success();
    }

    // @PreAuthorize("hasAnyAuthority('reportDatasource:execSql')")
    @PostMapping("/execSql")
    public Result<?> execSql(@RequestBody ExecSql execSql) {
        return Result.success(reportDatasourceService.execSql(execSql));
    }

    @PostMapping("/connection")
    public Result<Boolean> testConnection(@RequestBody ReportDataSource reportDataSource) {
        return Result.success(reportDatasourceService.testConnection(reportDataSource));
    }

}
