package com.flow.controller;

import com.flow.common.core.model.PageResult;
import com.flow.common.core.model.Result;
import com.flow.entity.ReportTemplate;
import com.flow.model.ReportTemplateQuery;
import com.flow.service.ReportTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Set;

@RestController
@RequestMapping("/reportTemplate")
public class ReportTemplateController {
    @Autowired
    private ReportTemplateService reportTemplateService;

    @GetMapping
    public Result<PageResult<ReportTemplate>> getList(ReportTemplateQuery reportTemplateQuery) {
        PageResult<ReportTemplate> list = reportTemplateService.getList(reportTemplateQuery);
        return Result.success(list);
    }

    @GetMapping("/{id}")
    public Result<ReportTemplate> getTemplate(@PathVariable String id) {
        ReportTemplate template = reportTemplateService.getTemplate(id);
        return Result.success(template);
    }

    // @PreAuthorize("hasAnyAuthority('reportTemplate:add')")
    @PostMapping
    public Result<ReportTemplate> create(@RequestBody ReportTemplate reportTemplate) {
        return Result.success(reportTemplateService.create(reportTemplate));
    }

    // @PreAuthorize("hasAnyAuthority('reportTemplate:edit')")
    @PutMapping
    public Result<ReportTemplate> update(@RequestBody ReportTemplate reportTemplate) {
        return Result.success(reportTemplateService.update(reportTemplate));
    }

    // @PreAuthorize("hasAnyAuthority('reportTemplate:del')")
    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        reportTemplateService.delete(ids);
        return Result.success();
    }

}
