package com.flow.service;

import com.flow.common.core.model.PageResult;
import com.flow.common.mybatis.service.BaseService;
import com.flow.entity.Role;
import com.flow.entity.StorageFile;
import com.flow.entity.User;
import com.flow.model.UserQuery;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Set;

public interface UserService extends BaseService<User> {

    List<User> search(UserQuery userQuery);

    PageResult<User> getList(UserQuery userQuery);

    List<Role> getRoles(String userId);

    void authRoles(String userId, Set<String> roleIds);

    List<User> getOptions(Set<String> userIds);

    User getByUsername(String username);

    User create(User user);

    User update(User user);

    void delete(Set<Long> ids);

    StorageFile updateAvatar(MultipartFile multipartFile) throws IOException;

    void resetPassword(String username);

    User getLeader(String username, Integer level);

    User getLeader(String username);

    User getOrgLeader(String username);

    User getOrgLeader(String username, Integer level);
}
