package com.flow.dao;


import com.flow.common.mybatis.dao.BaseDao;
import com.flow.entity.Menu;
import com.flow.entity.Role;
import com.flow.entity.User;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface RoleDao extends BaseDao<Role> {

    @Select("select * from sys_menu where id in (SELECT menu_id from sys_role_menu where role_id = #{roleId})")
    List<Menu> getPermission(@Param("roleId") Long roleId);

    @Insert({
            "<script>",
            "INSERT IGNORE INTO sys_role_menu (role_id, menu_id) VALUES"
                    + "<foreach collection='menuIds' item='menuId' separator=','>"
                    + "   (#{roleId}, #{menuId})"
                    + "</foreach>",
            "</script>"
    })
    void setPermission(@Param("roleId") Long roleId, @Param("menuIds") List<Long> menuIds);

    @Delete({
            "<script>",
            "DELETE FROM sys_role_menu WHERE role_id = #{roleId} AND menu_id NOT IN"
                    + "<foreach item='menuId' collection='menuIds' separator=',' open='(' close=')'>"
                    + "#{menuId}"
                    + "</foreach>",
            "</script>"
    })
    void delPermission(@Param("roleId") Long roleId, @Param("menuIds") List<Long> menuIds);


    @Select({
            "<script>",
            "select * from sys_user where username in (select user_id from sys_user_role where role_id in "
                    + "<foreach item='id' collection='roleIds' open='(' separator=',' close=')'>"
                    + "#{id}"
                    + "</foreach>)",
            "</script>"
    })
    List<User> getUsersByIds(@Param("roleIds") List<String> roleIds);

    @Select("select * from sys_user where username in (select user_id from sys_user_role where role_id = #{roleId})")
    List<User> getUsers(@Param("roleId") String roleId);

}
