package com.flow.dao;


import com.flow.common.mybatis.dao.BaseDao;
import com.flow.entity.Role;
import com.flow.entity.User;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Set;

public interface UserDao extends BaseDao<User> {

    @Select("select * from sys_role where id in (SELECT role_id from sys_user_role where user_id = #{userId})")
    List<Role> getRoles(String userId);

    @Insert({
            "<script>",
            "INSERT IGNORE INTO sys_user_role (user_id, role_id) VALUES"
                    + "<foreach collection='roleIds' item='roleId' separator=','>"
                    + "   (#{userId}, #{roleId})"
                    + "</foreach>",
            "</script>"
    })
    void authRoles(@Param("userId") String userId, @Param("roleIds") Set<String> roleIds);

    @Delete({
            "<script>",
            "DELETE FROM sys_user_role WHERE user_id = #{userId} AND role_id NOT IN"
                    + "<foreach item='roleId' collection='roleIds' separator=',' open='(' close=')'>"
                    + "#{roleId}"
                    + "</foreach>",
            "</script>"
    })
    void delNotExistRoles(@Param("userId") String userId, @Param("roleIds") Set<String> roleIds);

    @Select("select * from sys_user where username = #{username}")
    User getLeader(@Param("username") String username);

    @Select("select * from sys_user where username = (select leader from sys_dept where id = (select dept_id from sys_user where username = #{username}))")
    User getOrgLeader(@Param("username") String username);
}
