package com.flow.controller;

import com.flow.common.core.model.PageResult;
import com.flow.common.core.model.Result;
import com.flow.entity.Dict;
import com.flow.model.DictQuery;
import com.flow.service.DictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.Set;


@RestController
@RequestMapping("/dict")
public class DictController {
    @Autowired
    private DictService dictService;

    @GetMapping
    public Result<PageResult<Dict>> getList(DictQuery dictQuery) {
        return Result.success(dictService.getList(dictQuery));
    }

    @PreAuthorize("hasAnyAuthority('dict:add')")
    @PostMapping
    public Result<Dict> create(@RequestBody Dict dict) {
        return Result.success(dictService.create(dict));
    }

    @PreAuthorize("hasAnyAuthority('dict:edit')")
    @PutMapping
    public Result<Dict> update(@RequestBody Dict dict) {
        return Result.success(dictService.update(dict));
    }

    @PreAuthorize("hasAnyAuthority('dict:del')")
    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        dictService.delete(ids);
        return Result.success();
    }
}
