package com.flow.controller;

import com.flow.common.core.model.Result;
import com.flow.entity.Menu;
import com.flow.model.MenuQuery;
import com.flow.service.MenuService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Set;


@RestController
@RequestMapping("/menu")
public class MenuController {
    @Autowired
    private MenuService menuService;

    @GetMapping
    public Result<List<Menu>> getTree(MenuQuery menuQuery) {
        return Result.success(menuService.getTree(menuQuery));
    }

    @PreAuthorize("hasAnyAuthority('menu:add')")
    @PostMapping
    public Result<Menu> create(@RequestBody Menu menu) {
        return Result.success(menuService.create(menu));
    }

    @PreAuthorize("hasAnyAuthority('menu:edit')")
    @PutMapping
    public Result<Menu> update(@RequestBody Menu menu) {
        return Result.success(menuService.update(menu));
    }

    @PreAuthorize("hasAnyAuthority('menu:del')")
    @DeleteMapping
    public Result<?> delete(@RequestBody Set<Long> ids) {
        menuService.delete(ids);
        return Result.success();
    }
}
