package com.flow.entity;

import com.baomidou.mybatisplus.annotation.SqlCondition;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.flow.common.mybatis.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName("sys_menu")
public class Menu extends BaseEntity {
    @JsonSerialize(using = ToStringSerializer.class)
    private Long pid;
    private Integer type;
    @TableField(condition = SqlCondition.LIKE)
    private String name;
    private Integer sort;
    private String path;
    private String component;
    private String redirect;
    @TableField(condition = SqlCondition.LIKE)
    private String title;
    private String icon;
    @TableField(value = "keep_alive")
    private Boolean cache;
    private Boolean hidden;
    private Boolean affix;
    private String activeMenu;
    private String permission;
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    @TableField(exist = false)
    private List<Menu> children;
}
