package com.flow.entity;

import com.baomidou.mybatisplus.annotation.SqlCondition;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.flow.common.mybatis.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.codehaus.jackson.annotate.JsonIgnore;

import java.util.Set;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName("sys_user")
public class User extends BaseEntity {
    @TableField(condition = SqlCondition.LIKE)
    private String name;
    private String username;
    @JsonIgnore
    private String password;
    private String avatar;
    private Integer sex;
    private String phone;
    private String email;
    private Boolean enabled;
    private String leader;
    @JsonSerialize(using = ToStringSerializer.class)
    private Long deptId;
    @TableField(exist = false)
    private Set<String> roleIds;
}
