package com.flow.service;

import com.flow.common.mybatis.service.BaseService;
import com.flow.entity.FlowGroup;

import java.util.List;
import java.util.Set;

public interface FlowGroupService extends BaseService<FlowGroup> {
    /**
     * 流程分组列表
     * @param flowGroup
     * @return
     */
    List<FlowGroup> list(FlowGroup flowGroup);

    /**
     * 参加分组
     * @param flowGroup
     * @return
     */
    FlowGroup create(FlowGroup flowGroup);

    /**
     * 更新分组
     * @param flowGroup
     * @return
     */
    FlowGroup update(FlowGroup flowGroup);

    /**
     * 删除分组
     * @param ids
     */
    void delete(Set<Long> ids);

    /**
     * 分组排序
     * @param newId
     * @param oldId
     */
    void sort(String newId, String oldId);

}
