package com.flow.config;

import org.flowable.common.engine.impl.persistence.deploy.DeploymentCache;
import org.flowable.engine.impl.persistence.deploy.ProcessDefinitionCacheEntry;
import org.springframework.stereotype.Component;

import java.util.Collection;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

@Component
public class CustomDeploymentCache implements DeploymentCache<ProcessDefinitionCacheEntry> {
    protected Map<String, ProcessDefinitionCacheEntry> cache = new ConcurrentHashMap<>();

    @Override
    public ProcessDefinitionCacheEntry get(String s) {
        return cache.get(s);
    }

    @Override
    public boolean contains(String s) {
        return cache.containsKey(s);
    }

    @Override
    public void add(String s, ProcessDefinitionCacheEntry processDefinitionCacheEntry) {
        cache.put(s, processDefinitionCacheEntry);
    }

    @Override
    public void remove(String s) {
        cache.remove(s);
    }

    @Override
    public void clear() {
        cache.clear();
    }

    @Override
    public Collection<ProcessDefinitionCacheEntry> getAll() {
        return cache.values();
    }

    @Override
    public int size() {
        return cache.size();
    }
}
