package com.flow.config;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import org.flowable.common.engine.impl.cfg.IdGenerator;
import org.flowable.task.service.TaskPostProcessor;
import org.flowable.task.service.impl.persistence.entity.TaskEntity;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class WorkflowConfig {


    @Bean
    public IdGenerator getIdGenerator() {

        /**
         * 使用雪花算法生成id
         */
        return new IdGenerator() {
            @Override
            public String getNextId() {
                return String.valueOf(IdWorker.getId());
            }
        };
    }

    /**
     * 创建任务后处理器
     * @return
     */
    @Bean
    public TaskPostProcessor CustomTaskPostProcessor() {
        return new TaskPostProcessor() {
            @Override
            public TaskEntity enrich(TaskEntity taskEntityToEnrich) {
                taskEntityToEnrich.setId(IdWorker.getIdStr());
                return taskEntityToEnrich;
            }
        };
    }
}
