package com.flow.controller;

import com.flow.common.core.model.Result;
import com.flow.entity.FlowDefine;
import com.flow.model.FormInfo;
import com.flow.model.StartProcess;
import com.flow.service.FlowDefineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/define")
public class FlowDefineController {
    @Autowired
    private FlowDefineService flowDefineService;

    @PostMapping("/start")
    public Result<?> start(@RequestBody StartProcess startProcess) {
        flowDefineService.startProcess(startProcess);
        return Result.success();
    }

    @GetMapping
    public Result<List<FlowDefine>> list(FlowDefine flowDefine) {
        return Result.success(flowDefineService.list(flowDefine));
    }

    @PutMapping("/suspend/{defineId}")
    public Result<FlowDefine> suspend(@PathVariable String defineId) {
        return Result.success(flowDefineService.suspend(defineId));
    }

    @GetMapping("/{defineId}")
    public Result<FlowDefine> getDefine(@PathVariable String defineId) {
        return Result.success(flowDefineService.getDefine(defineId));
    }

    @GetMapping("/startForm/{defineId}")
    public Result<FormInfo> getStartForm(@PathVariable String defineId) {
        FormInfo formInfo = flowDefineService.getStartForm(defineId);
        return Result.success(formInfo);
    }

}
