package com.flow.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.flow.enums.ProcessStatus;
import com.flow.model.FlowComment;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;
import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class FlowActivity {
    // id
    private String id;
    // 节点id
    private String nodeId;
    // 多实例类型
    private String multiType;
    // 节点类型
    private String nodeType;
    // 节点名称
    private String nodeName;
    // 开始时间
    private LocalDateTime startTime;
    // 结束时间
    private LocalDateTime endTime;
    // 流程实例id
    private String instanceId;
    // 流程定义id
    private String defineId;
    // 父节点id
    private String parentId;
    // 执行id
    private String executionId;
    // 任务id
    private String taskId;
    // 处理用户
    private String userId;
    // 状态
    private ProcessStatus status;
    // 评论
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    @TableField(typeHandler = JacksonTypeHandler.class)
    private List<FlowComment> flowComment;
}
