package com.flow.entity;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.engine.impl.persistence.deploy.ProcessDefinitionCacheEntry;
import org.flowable.engine.repository.ProcessDefinition;

import java.io.Serializable;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class ProcessDefinitionCache implements Serializable {
    private static final long serialVersionUID = 6833801933658529170L;
    @JsonIgnoreProperties(ignoreUnknown = true)
    private ProcessDefinition processDefinition;
    private BpmnModel bpmnModel;

    public ProcessDefinitionCache(ProcessDefinitionCacheEntry processDefinitionCacheEntry) {
        this.processDefinition = processDefinitionCacheEntry.getProcessDefinition();
        this.bpmnModel = processDefinitionCacheEntry.getBpmnModel();
    }

    public ProcessDefinitionCacheEntry toProcessDefinitionCacheEntry() {
        return new ProcessDefinitionCacheEntry(processDefinition, bpmnModel, bpmnModel.getMainProcess());
    }
}
