package com.flow.entity.form;

import com.flow.entity.node.FormProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.List;
import java.util.Map;
import java.util.Objects;


@EqualsAndHashCode(callSuper = true)
@Data
public class FormItem extends Field implements Serializable {
    private static final long serialVersionUID = 1L;
    private Object value;
    private Boolean readonly;
    private Boolean required;
    private List<Object> rules;

    @Override
    public void populateValue(Map<String, Object> variables) {
        if (Objects.nonNull(variables)) {
            Object val = variables.get(this.getId());
            if (Objects.nonNull(val)) {
                this.value = val;
            }
        }
    }

    @Override
    public void populateProperty(FormProperty formProperty) {
        if (Objects.nonNull(formProperty)) {
            this.setHidden(formProperty.getHidden());
            this.setReadonly(formProperty.getReadonly());
            this.setRequired(formProperty.getRequired());
        }
    }
}
