/*
 Navicat Premium Data Transfer

 Source Server         : 本机mysql
 Source Server Type    : MySQL
 Source Server Version : 80027 (8.0.27)
 Source Host           : localhost:3306
 Source Schema         : flow

 Target Server Type    : MySQL
 Target Server Version : 80027 (8.0.27)
 File Encoding         : 65001

 Date: 12/06/2024 13:31:16
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;


-- ----------------------------
-- Table structure for flow_define
-- ----------------------------
DROP TABLE IF EXISTS `flow_define`;
CREATE TABLE `flow_define`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `icon` json NOT NULL COMMENT '图标',
  `define_id` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '流程id',
  `model_id` bigint UNSIGNED NOT NULL COMMENT '模型id',
  `process` json NOT NULL COMMENT '流程',
  `form` json NULL COMMENT '表单',
  `starter_users` json NULL COMMENT '授权发起人',
  `admin` json NOT NULL COMMENT '流程管理员',
  `settings` json NOT NULL COMMENT '高级设置',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 149 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_define
-- ----------------------------

-- ----------------------------
-- Table structure for flow_group
-- ----------------------------
DROP TABLE IF EXISTS `flow_group`;
CREATE TABLE `flow_group`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(150) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `sort` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '排序',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`, `sort`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 6 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_group
-- ----------------------------

-- ----------------------------
-- Table structure for flow_instance
-- ----------------------------
DROP TABLE IF EXISTS `flow_instance`;
CREATE TABLE `flow_instance`  (
  `id` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT 'id',
  `status` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '状态',
  `cancel_days` int unsigned NOT NULL DEFAULT '0' COMMENT '撤回天数',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_instance
-- ----------------------------

-- ----------------------------
-- Table structure for flow_model
-- ----------------------------
DROP TABLE IF EXISTS `flow_model`;
CREATE TABLE `flow_model`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `code` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '编号',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '流程名称',
  `icon` json NOT NULL COMMENT '图标',
  `sort` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '排序',
  `form` json NOT NULL COMMENT '表单',
  `process` json NOT NULL COMMENT '流程',
  `version` int UNSIGNED NOT NULL DEFAULT 1 COMMENT '版本',
  `group_id` bigint NOT NULL COMMENT '分组id',
  `admin` json NOT NULL COMMENT '流程管理员',
  `settings` json NOT NULL COMMENT '高级设置',
  `enable` tinyint UNSIGNED NOT NULL DEFAULT 1 COMMENT '是否启用',
  `remark` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '备注',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 28 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_model
-- ----------------------------

-- ----------------------------
-- Table structure for flow_model_history
-- ----------------------------
DROP TABLE IF EXISTS `flow_model_history`;
CREATE TABLE `flow_model_history`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `model_id` bigint NOT NULL COMMENT '模型id',
  `code` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '流程编号',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '流程名称',
  `icon` json NOT NULL COMMENT '图标',
  `sort` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '排序',
  `form` json NOT NULL COMMENT '表单',
  `process` json NOT NULL COMMENT '流程',
  `version` int UNSIGNED NOT NULL DEFAULT 1 COMMENT '版本',
  `group_id` bigint NOT NULL COMMENT '分组id',
  `admin` json NOT NULL COMMENT '流程管理员',
  `enable` tinyint UNSIGNED NOT NULL DEFAULT 1 COMMENT '是否启用',
  `remark` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '备注',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 65 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_model_history
-- ----------------------------

-- ----------------------------
-- Table structure for flow_task
-- ----------------------------
DROP TABLE IF EXISTS `flow_task`;
CREATE TABLE `flow_task`  (
  `id` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT 'id',
  `instance_id` varchar(64) NOT NULL COMMENT '实例id',
  `status` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '状态',
  `variables` json NOT NULL COMMENT '变量',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of flow_task
-- ----------------------------

-- ----------------------------
-- Table structure for oauth_access_token
-- ----------------------------
DROP TABLE IF EXISTS `oauth_access_token`;
CREATE TABLE `oauth_access_token`  (
  `token_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `token` blob NULL,
  `authentication_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `user_name` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `client_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `authentication` blob NULL,
  `refresh_token` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL
) ENGINE = MyISAM AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_access_token
-- ----------------------------

-- ----------------------------
-- Table structure for oauth_approvals
-- ----------------------------
DROP TABLE IF EXISTS `oauth_approvals`;
CREATE TABLE `oauth_approvals`  (
  `userId` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `clientId` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `scope` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `status` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `expiresAt` timestamp NULL DEFAULT NULL,
  `lastModifiedAt` timestamp NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_approvals
-- ----------------------------

-- ----------------------------
-- Table structure for oauth_client_details
-- ----------------------------
DROP TABLE IF EXISTS `oauth_client_details`;
CREATE TABLE `oauth_client_details`  (
  `client_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL,
  `resource_ids` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `client_secret` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `scope` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `authorized_grant_types` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `web_server_redirect_uri` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `authorities` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `access_token_validity` int NULL DEFAULT NULL,
  `refresh_token_validity` int NULL DEFAULT NULL,
  `additional_information` varchar(4096) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `autoapprove` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '设置用户是否自动Approval操作',
  PRIMARY KEY (`client_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_client_details
-- ----------------------------
INSERT INTO `oauth_client_details` VALUES ('client', 'flow-app', '$2a$10$F5GU8qUHdWVsoNVHjqN4c.EElCrBB7ywCiSDn3ibW4e4RdKyhe1PK', 'web', 'refresh_token,password,authorization_code', NULL, '', 43000, 2592000, '{}', '');

-- ----------------------------
-- Table structure for oauth_client_token
-- ----------------------------
DROP TABLE IF EXISTS `oauth_client_token`;
CREATE TABLE `oauth_client_token`  (
  `token_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `token` blob NULL,
  `authentication_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL,
  `user_name` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `client_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  PRIMARY KEY (`authentication_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_client_token
-- ----------------------------

-- ----------------------------
-- Table structure for oauth_code
-- ----------------------------
DROP TABLE IF EXISTS `oauth_code`;
CREATE TABLE `oauth_code`  (
  `code` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `authentication` blob NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_code
-- ----------------------------

-- ----------------------------
-- Table structure for oauth_refresh_token
-- ----------------------------
DROP TABLE IF EXISTS `oauth_refresh_token`;
CREATE TABLE `oauth_refresh_token`  (
  `token_id` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL,
  `token` blob NULL,
  `authentication` blob NULL
) ENGINE = MyISAM AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of oauth_refresh_token
-- ----------------------------

-- ----------------------------
-- Table structure for sys_dept
-- ----------------------------
DROP TABLE IF EXISTS `sys_dept`;
CREATE TABLE `sys_dept`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `pid` bigint UNSIGNED NOT NULL DEFAULT 0 COMMENT '上级部门',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '部门名称',
  `sort` int UNSIGNED NOT NULL COMMENT '排序',
  `leader` varchar(40) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '负责人',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1538427176800514051 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_dept
-- ----------------------------
INSERT INTO `sys_dept` VALUES (1357882410670682114, 1538426269257986049, '开发部', 0, 'yangyingqiu', '1356976230017601538', 'admin', '2021-02-06 10:42:50', '2024-04-18 21:44:38');
INSERT INTO `sys_dept` VALUES (1357882876154490881, 1538426198781095937, '销售部', 0, 'wumingjie', '1356976230017601538', 'admin', '2021-02-06 10:44:41', '2024-04-18 21:44:28');
INSERT INTO `sys_dept` VALUES (1357882876154490882, 1357882410670682114, '开发一部', 0, 'shenhanlin', '1356976230017601538', 'admin', '2021-02-06 10:44:41', '2024-04-20 21:44:04');
INSERT INTO `sys_dept` VALUES (1538426048373354498, 0, '无名科技有限公司', 0, 'caiyan', 'admin', 'admin', '2022-06-19 15:38:47', '2024-04-18 21:36:15');
INSERT INTO `sys_dept` VALUES (1538426198781095937, 1538426048373354498, '杭州总公司', 0, 'zhouyafu', 'admin', 'admin', '2022-06-19 15:39:23', '2024-04-18 21:38:07');
INSERT INTO `sys_dept` VALUES (1538426269257986049, 1538426048373354498, '宁波分公司', 1, 'shenhanlin', 'admin', 'admin', '2022-06-19 15:39:40', '2024-04-18 21:38:17');
INSERT INTO `sys_dept` VALUES (1538426418701037570, 1538426198781095937, '市场部', 1, 'admin', 'admin', 'admin', '2022-06-19 15:40:15', '2024-04-20 21:43:16');
INSERT INTO `sys_dept` VALUES (1538426483670806530, 1538426198781095937, '开发部', 2, 'yaotong', 'admin', 'admin', '2022-06-19 15:40:31', '2024-04-20 21:43:26');
INSERT INTO `sys_dept` VALUES (1538426509662908418, 1538426198781095937, '运维部', 3, 'matao', 'admin', 'admin', '2022-06-19 15:40:37', '2024-04-20 21:43:36');
INSERT INTO `sys_dept` VALUES (1538426603464323074, 1538426269257986049, '销售部', 1, NULL, 'admin', 'admin', '2022-06-19 15:41:00', '2022-06-19 15:49:50');
INSERT INTO `sys_dept` VALUES (1538426719302610945, 1538426198781095937, '财务部', 4, 'zhengfei', 'admin', 'admin', '2022-06-19 15:41:27', '2024-04-20 21:43:45');
INSERT INTO `sys_dept` VALUES (1538426749530959874, 1538426198781095937, '研发部门', 5, NULL, 'admin', 'admin', '2022-06-19 15:41:34', '2022-06-19 15:49:38');
INSERT INTO `sys_dept` VALUES (1538426900681093121, 1538426048373354498, '上海分公司', 2, 'yaotong', 'admin', 'admin', '2022-06-19 15:42:10', '2024-04-18 21:41:15');
INSERT INTO `sys_dept` VALUES (1538426930959773697, 1538426900681093121, '销售部', 0, NULL, 'admin', 'admin', '2022-06-19 15:42:18', '2022-06-19 15:50:06');
INSERT INTO `sys_dept` VALUES (1538427000094486529, 1538426048373354498, '华北分部', 3, 'wufeihong', 'admin', 'admin', '2022-06-19 15:42:34', '2024-04-18 21:41:48');
INSERT INTO `sys_dept` VALUES (1538427031631458306, 1538427000094486529, '销售部', 0, 'caiyan', 'admin', 'admin', '2022-06-19 15:42:42', '2024-04-18 21:41:40');
INSERT INTO `sys_dept` VALUES (1538427101365956610, 1538426048373354498, '华西分部', 4, 'wumingjie', 'admin', 'admin', '2022-06-19 15:42:58', '2024-04-20 21:43:06');
INSERT INTO `sys_dept` VALUES (1538427176800514050, 1538427101365956610, '销售部', 0, NULL, 'admin', 'admin', '2022-06-19 15:43:16', '2022-06-19 15:50:16');

-- ----------------------------
-- Table structure for sys_dict
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict`;
CREATE TABLE `sys_dict`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT,
  `code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '编号',
  `name` varchar(150) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '字典名称',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '描述',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1611331866129420291 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_dict
-- ----------------------------
INSERT INTO `sys_dict` VALUES (1, 'system', '服务模块', '服务模块2', '1356976230017601538', 'admin', '2021-12-19 21:50:52', '2024-03-28 21:21:41');
INSERT INTO `sys_dict` VALUES (1611331866129420290, 'notify_type', '消息通知类型', '消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型消息通知类型', 'admin', 'admin', '2023-01-06 20:00:29', '2024-03-28 21:21:50');

-- ----------------------------
-- Table structure for sys_dict_detail
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict_detail`;
CREATE TABLE `sys_dict_detail`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `dict_code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '字典id',
  `label` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '字典标签',
  `value` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '字典值',
  `sort` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '排序',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1611334000531034114 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_dict_detail
-- ----------------------------
INSERT INTO `sys_dict_detail` VALUES (1611331993917280257, 'notify_type', '代办', 'agency', 999, 'admin', 'admin', '2023-01-06 20:00:59', '2023-01-06 20:03:24');
INSERT INTO `sys_dict_detail` VALUES (1611332573649784834, 'notify_type', '公告', 'notice', 999, 'admin', 'admin', '2023-01-06 20:03:17', '2023-01-06 20:06:39');
INSERT INTO `sys_dict_detail` VALUES (1611332725118685186, 'notify_type', '通知', 'notify', 999, 'admin', 'admin', '2023-01-06 20:03:53', '2023-01-06 20:06:37');
INSERT INTO `sys_dict_detail` VALUES (1611332756219449345, 'notify_type', '消息', 'message', 999, 'admin', NULL, '2023-01-06 20:04:01', NULL);
INSERT INTO `sys_dict_detail` VALUES (1611334000531034113, 'notify_type', '其他', 'other', 999, 'admin', NULL, '2023-01-06 20:08:58', NULL);

-- ----------------------------
-- Table structure for sys_file
-- ----------------------------
DROP TABLE IF EXISTS `sys_file`;
CREATE TABLE `sys_file`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '文件名称',
  `real_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '真实文件名称',
  `path` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '路径',
  `url` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '预览地址',
  `type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '类型',
  `category` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT '类别',
  `md5` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_as_cs NOT NULL COMMENT 'md5',
  `size` bigint UNSIGNED NOT NULL COMMENT '大小',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 87 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_file
-- ----------------------------
INSERT INTO `sys_file` VALUES (1, '会签.svg', '5c1570a4-540c-481b-b6f1-d0946a55a765会签.svg', 'D:\\admin\\file\\5c1570a4-540c-481b-b6f1-d0946a55a765会签.svg', '/static/file/5c1570a4-540c-481b-b6f1-d0946a55a765会签.svg', '.svg', 'other', '1458fad3481bd8126773970fa8f705ce', 1383, 'admin', NULL, '2024-03-17 14:46:09', NULL);
INSERT INTO `sys_file` VALUES (2, 'hide.svg', '4293a2a8-f6b2-4494-8e31-780c1e763ee4hide.svg', 'D:\\admin\\file\\4293a2a8-f6b2-4494-8e31-780c1e763ee4hide.svg', '/static/file/4293a2a8-f6b2-4494-8e31-780c1e763ee4hide.svg', '.svg', 'other', '09fe9bb38aeaf9c8597097d24971163f', 745, 'admin', NULL, '2024-03-17 14:46:18', NULL);
INSERT INTO `sys_file` VALUES (3, 'user-group.svg', 'd0d33acb-46d2-4453-b98d-e26460effbecuser-group.svg', 'D:\\admin\\file\\d0d33acb-46d2-4453-b98d-e26460effbecuser-group.svg', '/static/file/d0d33acb-46d2-4453-b98d-e26460effbecuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-17 14:50:31', NULL);
INSERT INTO `sys_file` VALUES (4, 'hide.svg', '310e53f5-bd99-437c-9d94-0959ba25c43ahide.svg', 'D:\\admin\\file\\310e53f5-bd99-437c-9d94-0959ba25c43ahide.svg', '/static/file/310e53f5-bd99-437c-9d94-0959ba25c43ahide.svg', '.svg', 'other', '09fe9bb38aeaf9c8597097d24971163f', 745, 'admin', NULL, '2024-03-17 14:50:39', NULL);
INSERT INTO `sys_file` VALUES (5, 'add-user.svg', 'd3f98069-78dc-45c5-a762-e5d993588c4eadd-user.svg', 'D:\\admin\\file\\d3f98069-78dc-45c5-a762-e5d993588c4eadd-user.svg', '/static/file/d3f98069-78dc-45c5-a762-e5d993588c4eadd-user.svg', '.svg', 'other', 'f049032843b432bd708de46dce20cf98', 1489, 'admin', NULL, '2024-03-17 14:51:51', NULL);
INSERT INTO `sys_file` VALUES (6, 'signature.png', 'a610b271-2064-4d6b-923e-4a62bbd60e66signature.png', 'D:\\admin\\file\\a610b271-2064-4d6b-923e-4a62bbd60e66signature.png', '/static/file/a610b271-2064-4d6b-923e-4a62bbd60e66signature.png', '.png', 'other', '2347ca239e8d6c96f2866887e006058a', 28042, 'admin', NULL, '2024-03-17 14:51:57', NULL);
INSERT INTO `sys_file` VALUES (7, 'signature.png', '14fd4017-5bb3-4e1c-ad4d-89669e932b92signature.png', 'D:\\admin\\file\\14fd4017-5bb3-4e1c-ad4d-89669e932b92signature.png', '/static/file/14fd4017-5bb3-4e1c-ad4d-89669e932b92signature.png', '.png', 'other', '268cb67e18ee6095674fe9123f2d8856', 28352, 'admin', NULL, '2024-03-17 14:52:45', NULL);
INSERT INTO `sys_file` VALUES (8, 'user-group.svg', '4cfaee7a-3cc9-44a0-8b45-a85696ea145cuser-group.svg', 'D:\\admin\\file\\4cfaee7a-3cc9-44a0-8b45-a85696ea145cuser-group.svg', '/static/file/4cfaee7a-3cc9-44a0-8b45-a85696ea145cuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-17 14:52:51', NULL);
INSERT INTO `sys_file` VALUES (9, 'heroicons--user-group-16-solid.svg', '9be12b75-0193-4be3-91e2-7eddd9e25ad1heroicons--user-group-16-solid.svg', 'D:\\admin\\file\\9be12b75-0193-4be3-91e2-7eddd9e25ad1heroicons--user-group-16-solid.svg', '/static/file/9be12b75-0193-4be3-91e2-7eddd9e25ad1heroicons--user-group-16-solid.svg', '.svg', 'other', 'd2073f80ca28b1d317e8a3567d09b9f2', 569, 'admin', NULL, '2024-03-17 14:53:54', NULL);
INSERT INTO `sys_file` VALUES (10, 'signature.png', '9ceac522-a683-45fe-885d-fc95547f732csignature.png', 'D:\\admin\\file\\9ceac522-a683-45fe-885d-fc95547f732csignature.png', '/static/file/9ceac522-a683-45fe-885d-fc95547f732csignature.png', '.png', 'other', 'c7fbd6f5962a9b46053e4116532951f9', 31614, 'admin', NULL, '2024-03-17 16:31:07', NULL);
INSERT INTO `sys_file` VALUES (11, 'user-group.svg', '61832c5d-eb2c-4eea-8005-9652dabf968cuser-group.svg', 'D:\\admin\\file\\61832c5d-eb2c-4eea-8005-9652dabf968cuser-group.svg', '/static/file/61832c5d-eb2c-4eea-8005-9652dabf968cuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-17 20:55:19', NULL);
INSERT INTO `sys_file` VALUES (12, 'add-user.svg', 'a715d602-a21d-4e06-9d85-bd228cc85640add-user.svg', 'D:\\admin\\file\\a715d602-a21d-4e06-9d85-bd228cc85640add-user.svg', '/static/file/a715d602-a21d-4e06-9d85-bd228cc85640add-user.svg', '.svg', 'other', 'f049032843b432bd708de46dce20cf98', 1489, 'admin', NULL, '2024-03-17 20:55:21', NULL);
INSERT INTO `sys_file` VALUES (13, '会签.svg', '8a7d3e5a-9d67-4bc4-9af4-a6c3af7f2a3d会签.svg', 'D:\\admin\\file\\8a7d3e5a-9d67-4bc4-9af4-a6c3af7f2a3d会签.svg', '/static/file/8a7d3e5a-9d67-4bc4-9af4-a6c3af7f2a3d会签.svg', '.svg', 'other', '1458fad3481bd8126773970fa8f705ce', 1383, 'admin', NULL, '2024-03-17 20:58:53', NULL);
INSERT INTO `sys_file` VALUES (14, 'user-group.svg', '2f69e8d8-6920-426c-829e-4ae806b22c49user-group.svg', 'D:\\admin\\file\\2f69e8d8-6920-426c-829e-4ae806b22c49user-group.svg', '/static/file/2f69e8d8-6920-426c-829e-4ae806b22c49user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-17 20:58:58', NULL);
INSERT INTO `sys_file` VALUES (15, 'signature.png', 'c109f302-7601-415a-bfc3-0aca6e970ccfsignature.png', 'D:\\admin\\file\\c109f302-7601-415a-bfc3-0aca6e970ccfsignature.png', '/static/file/c109f302-7601-415a-bfc3-0aca6e970ccfsignature.png', '.png', 'other', '651b4a9d0dafa05ecaacfd787ce85e0c', 26450, 'admin', NULL, '2024-03-17 23:14:12', NULL);
INSERT INTO `sys_file` VALUES (16, 'user-group.svg', '2c22d47d-175c-42dc-ae40-182e1d31f499user-group.svg', 'D:\\admin\\file\\2c22d47d-175c-42dc-ae40-182e1d31f499user-group.svg', '/static/file/2c22d47d-175c-42dc-ae40-182e1d31f499user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 12:05:07', NULL);
INSERT INTO `sys_file` VALUES (17, 'user-group.svg', 'e8aadd12-2e6a-4510-a12d-c7dd9f26d5e1user-group.svg', 'D:\\admin\\file\\e8aadd12-2e6a-4510-a12d-c7dd9f26d5e1user-group.svg', '/static/file/e8aadd12-2e6a-4510-a12d-c7dd9f26d5e1user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 12:11:12', NULL);
INSERT INTO `sys_file` VALUES (18, 'heroicons--user-group-16-solid.svg', '7fb6208a-2400-4fa4-b21c-3815f1c24d15heroicons--user-group-16-solid.svg', 'D:\\admin\\file\\7fb6208a-2400-4fa4-b21c-3815f1c24d15heroicons--user-group-16-solid.svg', '/static/file/7fb6208a-2400-4fa4-b21c-3815f1c24d15heroicons--user-group-16-solid.svg', '.svg', 'other', 'd2073f80ca28b1d317e8a3567d09b9f2', 569, 'admin', NULL, '2024-03-31 12:11:12', NULL);
INSERT INTO `sys_file` VALUES (19, '会签.svg', 'c8bfbfab-2a2f-4ef0-af8b-c7fafebb2276会签.svg', 'D:\\admin\\file\\c8bfbfab-2a2f-4ef0-af8b-c7fafebb2276会签.svg', '/static/file/c8bfbfab-2a2f-4ef0-af8b-c7fafebb2276会签.svg', '.svg', 'other', '1458fad3481bd8126773970fa8f705ce', 1383, 'admin', NULL, '2024-03-31 12:11:12', NULL);
INSERT INTO `sys_file` VALUES (20, 'user-group.svg', 'c3f86d51-11d5-4efe-ab02-16e050d85f27user-group.svg', 'D:\\admin\\file\\c3f86d51-11d5-4efe-ab02-16e050d85f27user-group.svg', '/static/file/c3f86d51-11d5-4efe-ab02-16e050d85f27user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:03:14', NULL);
INSERT INTO `sys_file` VALUES (21, 'user-group.svg', '79b6a45e-cd5d-4231-a25f-70f80578ad18user-group.svg', 'D:\\admin\\file\\79b6a45e-cd5d-4231-a25f-70f80578ad18user-group.svg', '/static/file/79b6a45e-cd5d-4231-a25f-70f80578ad18user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:06:13', NULL);
INSERT INTO `sys_file` VALUES (22, 'user-group.svg', 'e4a2290d-4f63-4bc1-a282-c6fd39d24212user-group.svg', 'D:\\admin\\file\\e4a2290d-4f63-4bc1-a282-c6fd39d24212user-group.svg', '/static/file/e4a2290d-4f63-4bc1-a282-c6fd39d24212user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:15:36', NULL);
INSERT INTO `sys_file` VALUES (23, 'user-group.svg', '342d2099-d026-4362-84e4-712a630fb830user-group.svg', 'D:\\admin\\file\\342d2099-d026-4362-84e4-712a630fb830user-group.svg', '/static/file/342d2099-d026-4362-84e4-712a630fb830user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:15:53', NULL);
INSERT INTO `sys_file` VALUES (24, 'user-group.svg', 'ae71f0fd-13a0-45e4-905c-aa81b4216ca2user-group.svg', 'D:\\admin\\file\\ae71f0fd-13a0-45e4-905c-aa81b4216ca2user-group.svg', '/static/file/ae71f0fd-13a0-45e4-905c-aa81b4216ca2user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:16:25', NULL);
INSERT INTO `sys_file` VALUES (25, 'user-group.svg', '51e9d0b6-c269-453e-a64d-734fddad64e9user-group.svg', 'D:\\admin\\file\\51e9d0b6-c269-453e-a64d-734fddad64e9user-group.svg', '/static/file/51e9d0b6-c269-453e-a64d-734fddad64e9user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:17:07', NULL);
INSERT INTO `sys_file` VALUES (26, 'user-group.svg', '0dd7ff3a-6bf1-4f08-9a06-797a98faddfeuser-group.svg', 'D:\\admin\\file\\0dd7ff3a-6bf1-4f08-9a06-797a98faddfeuser-group.svg', '/static/file/0dd7ff3a-6bf1-4f08-9a06-797a98faddfeuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:18:31', NULL);
INSERT INTO `sys_file` VALUES (27, '多人审批.svg', '9f176714-09a2-437a-a5b7-38c033d2ae1c多人审批.svg', 'D:\\admin\\file\\9f176714-09a2-437a-a5b7-38c033d2ae1c多人审批.svg', '/static/file/9f176714-09a2-437a-a5b7-38c033d2ae1c多人审批.svg', '.svg', 'other', '4bff4ed2715366bd12824bdd9b5d11a2', 2391, 'admin', NULL, '2024-03-31 14:19:16', NULL);
INSERT INTO `sys_file` VALUES (28, 'user-group.svg', '881e6a5a-2829-4530-88d9-a440ccf2235fuser-group.svg', 'D:\\admin\\file\\881e6a5a-2829-4530-88d9-a440ccf2235fuser-group.svg', '/static/file/881e6a5a-2829-4530-88d9-a440ccf2235fuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:23:43', NULL);
INSERT INTO `sys_file` VALUES (29, '会签.svg', 'd6889aca-732e-45ae-9d4d-c038d06bb573会签.svg', 'D:\\admin\\file\\d6889aca-732e-45ae-9d4d-c038d06bb573会签.svg', '/static/file/d6889aca-732e-45ae-9d4d-c038d06bb573会签.svg', '.svg', 'other', '1458fad3481bd8126773970fa8f705ce', 1383, 'admin', NULL, '2024-03-31 14:24:07', NULL);
INSERT INTO `sys_file` VALUES (30, '会签.svg', 'ccc418fd-2fae-4daf-8bbb-f2d39626094d会签.svg', 'D:\\admin\\file\\ccc418fd-2fae-4daf-8bbb-f2d39626094d会签.svg', '/static/file/ccc418fd-2fae-4daf-8bbb-f2d39626094d会签.svg', '.svg', 'other', '1458fad3481bd8126773970fa8f705ce', 1383, 'admin', NULL, '2024-03-31 14:24:55', NULL);
INSERT INTO `sys_file` VALUES (31, 'user-group.svg', '3eb7d86a-8a5c-410a-8e6b-bee1ce89f26duser-group.svg', 'D:\\admin\\file\\3eb7d86a-8a5c-410a-8e6b-bee1ce89f26duser-group.svg', '/static/file/3eb7d86a-8a5c-410a-8e6b-bee1ce89f26duser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:26:10', NULL);
INSERT INTO `sys_file` VALUES (32, 'user-group.svg', '6a13be7e-1722-4efe-8cc5-3e4846cd11fduser-group.svg', 'D:\\admin\\file\\6a13be7e-1722-4efe-8cc5-3e4846cd11fduser-group.svg', '/static/file/6a13be7e-1722-4efe-8cc5-3e4846cd11fduser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:30:51', NULL);
INSERT INTO `sys_file` VALUES (33, 'user-group.svg', '391edf83-5bab-4c8a-a0f1-cbd5c38305dauser-group.svg', 'D:\\admin\\file\\391edf83-5bab-4c8a-a0f1-cbd5c38305dauser-group.svg', '/static/file/391edf83-5bab-4c8a-a0f1-cbd5c38305dauser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:34:58', NULL);
INSERT INTO `sys_file` VALUES (34, 'user-group.svg', '9de0fdd3-7ae3-4fae-8566-f9cc2c3c77abuser-group.svg', 'D:\\admin\\file\\9de0fdd3-7ae3-4fae-8566-f9cc2c3c77abuser-group.svg', '/static/file/9de0fdd3-7ae3-4fae-8566-f9cc2c3c77abuser-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:39:59', NULL);
INSERT INTO `sys_file` VALUES (35, 'user-group.svg', 'c201bae2-17ee-4ed3-a4a5-1fead635b895user-group.svg', 'D:\\admin\\file\\c201bae2-17ee-4ed3-a4a5-1fead635b895user-group.svg', '/static/file/c201bae2-17ee-4ed3-a4a5-1fead635b895user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:40:47', NULL);
INSERT INTO `sys_file` VALUES (36, 'user-group.svg', '1acad03f-53a8-4a15-b470-e800974f13c4user-group.svg', 'D:\\admin\\file\\1acad03f-53a8-4a15-b470-e800974f13c4user-group.svg', '/static/file/1acad03f-53a8-4a15-b470-e800974f13c4user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:41:17', NULL);
INSERT INTO `sys_file` VALUES (37, 'user-group.svg', '083ed0c7-e59c-4cb8-96b3-0c665f133455user-group.svg', 'D:\\admin\\file\\083ed0c7-e59c-4cb8-96b3-0c665f133455user-group.svg', '/static/file/083ed0c7-e59c-4cb8-96b3-0c665f133455user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:53:27', NULL);
INSERT INTO `sys_file` VALUES (38, 'user-group.svg', '428d7f92-507b-497d-a4c5-1de8803faa41user-group.svg', 'D:\\admin\\file\\428d7f92-507b-497d-a4c5-1de8803faa41user-group.svg', '/static/file/428d7f92-507b-497d-a4c5-1de8803faa41user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 14:53:38', NULL);
INSERT INTO `sys_file` VALUES (39, 'user-group.svg', 'b5c10810-c200-4065-a9e8-c6e37ca4d473user-group.svg', 'D:\\admin\\file\\b5c10810-c200-4065-a9e8-c6e37ca4d473user-group.svg', '/static/file/b5c10810-c200-4065-a9e8-c6e37ca4d473user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 16:15:50', NULL);
INSERT INTO `sys_file` VALUES (40, 'user-group.svg', '48ed3625-ae28-4ade-8464-2f267a505de2user-group.svg', 'D:\\admin\\file\\48ed3625-ae28-4ade-8464-2f267a505de2user-group.svg', '/static/file/48ed3625-ae28-4ade-8464-2f267a505de2user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 16:18:16', NULL);
INSERT INTO `sys_file` VALUES (41, 'QQ截图20230907095049.png', '2a036c13-fe9f-412c-88b5-59268be535d1QQ截图20230907095049.png', 'D:\\admin\\file\\2a036c13-fe9f-412c-88b5-59268be535d1QQ截图20230907095049.png', '/static/file/2a036c13-fe9f-412c-88b5-59268be535d1QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 17:06:19', NULL);
INSERT INTO `sys_file` VALUES (42, 'QQ截图20230907095049.png', '293952e5-3b68-40ca-aa64-bfce6a419ac9QQ截图20230907095049.png', 'D:\\admin\\file\\293952e5-3b68-40ca-aa64-bfce6a419ac9QQ截图20230907095049.png', '/static/file/293952e5-3b68-40ca-aa64-bfce6a419ac9QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 17:06:52', NULL);
INSERT INTO `sys_file` VALUES (43, 'QQ截图20230907095049.png', 'a801291a-7736-4ec7-a013-d6f07e347406QQ截图20230907095049.png', 'D:\\admin\\file\\a801291a-7736-4ec7-a013-d6f07e347406QQ截图20230907095049.png', '/static/file/a801291a-7736-4ec7-a013-d6f07e347406QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 17:07:14', NULL);
INSERT INTO `sys_file` VALUES (44, 'QQ截图20230907095049.png', '96b40457-6ec0-4ffc-9c77-b72d7cff5445QQ截图20230907095049.png', 'D:\\admin\\file\\96b40457-6ec0-4ffc-9c77-b72d7cff5445QQ截图20230907095049.png', '/static/file/96b40457-6ec0-4ffc-9c77-b72d7cff5445QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 17:15:34', NULL);
INSERT INTO `sys_file` VALUES (45, '多人审批.svg', '0e8a9adb-2252-4ba3-bb92-06391187e8c3多人审批.svg', 'D:\\admin\\file\\0e8a9adb-2252-4ba3-bb92-06391187e8c3多人审批.svg', '/static/file/0e8a9adb-2252-4ba3-bb92-06391187e8c3多人审批.svg', '.svg', 'other', '4bff4ed2715366bd12824bdd9b5d11a2', 2391, 'admin', NULL, '2024-03-31 17:46:17', NULL);
INSERT INTO `sys_file` VALUES (46, 'QQ截图20230907095049.png', '36cf0651-2d65-4ccf-8e17-bfc639ba0570QQ截图20230907095049.png', 'D:\\admin\\file\\36cf0651-2d65-4ccf-8e17-bfc639ba0570QQ截图20230907095049.png', '/static/file/36cf0651-2d65-4ccf-8e17-bfc639ba0570QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 18:05:50', NULL);
INSERT INTO `sys_file` VALUES (47, 'user-group.svg', 'c58b290e-fcad-43a6-9bf7-f662260348e7user-group.svg', 'D:\\admin\\file\\c58b290e-fcad-43a6-9bf7-f662260348e7user-group.svg', '/static/file/c58b290e-fcad-43a6-9bf7-f662260348e7user-group.svg', '.svg', 'other', '86aa428578ed64bc83ffb3004d9f298a', 626, 'admin', NULL, '2024-03-31 18:06:05', NULL);
INSERT INTO `sys_file` VALUES (48, '多人审批.svg', '39d6c51c-c321-484a-9e7f-0a71fa3a6cbe多人审批.svg', 'D:\\admin\\file\\39d6c51c-c321-484a-9e7f-0a71fa3a6cbe多人审批.svg', '/static/file/39d6c51c-c321-484a-9e7f-0a71fa3a6cbe多人审批.svg', '.svg', 'other', '4bff4ed2715366bd12824bdd9b5d11a2', 2391, 'admin', NULL, '2024-03-31 18:06:08', NULL);
INSERT INTO `sys_file` VALUES (49, 'add-user.svg', '7a496724-62ef-4b12-ad27-dbd88c1ea3c3add-user.svg', 'D:\\admin\\file\\7a496724-62ef-4b12-ad27-dbd88c1ea3c3add-user.svg', '/static/file/7a496724-62ef-4b12-ad27-dbd88c1ea3c3add-user.svg', '.svg', 'other', 'f049032843b432bd708de46dce20cf98', 1489, 'admin', NULL, '2024-03-31 18:06:10', NULL);
INSERT INTO `sys_file` VALUES (50, 'QQ截图20230907095049.png', 'ed75a923-b884-4a70-b258-eef421e9b1eaQQ截图20230907095049.png', 'D:\\admin\\file\\ed75a923-b884-4a70-b258-eef421e9b1eaQQ截图20230907095049.png', '/static/file/ed75a923-b884-4a70-b258-eef421e9b1eaQQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 18:06:13', NULL);
INSERT INTO `sys_file` VALUES (51, 'squint-smile.svg', 'ba52bc98-db2a-43a3-92fe-c945d6213706squint-smile.svg', 'D:\\admin\\file\\ba52bc98-db2a-43a3-92fe-c945d6213706squint-smile.svg', '/static/file/ba52bc98-db2a-43a3-92fe-c945d6213706squint-smile.svg', '.svg', 'other', '0175956dcee86ff96a6904fe59eddeab', 2200, 'admin', NULL, '2024-03-31 18:06:16', NULL);
INSERT INTO `sys_file` VALUES (52, 'voice.svg', 'afb756a5-b3bb-4f40-a0a8-ad4373451565voice.svg', 'D:\\admin\\file\\afb756a5-b3bb-4f40-a0a8-ad4373451565voice.svg', '/static/file/afb756a5-b3bb-4f40-a0a8-ad4373451565voice.svg', '.svg', 'other', '13eea09347efeef9fd4b5bebf3fc4c49', 481, 'admin', NULL, '2024-03-31 19:06:04', NULL);
INSERT INTO `sys_file` VALUES (53, 'squint-smile.svg', '958e79d3-b136-45e8-a4a9-4d31dccf0f4dsquint-smile.svg', 'D:\\admin\\file\\958e79d3-b136-45e8-a4a9-4d31dccf0f4dsquint-smile.svg', '/static/file/958e79d3-b136-45e8-a4a9-4d31dccf0f4dsquint-smile.svg', '.svg', 'other', '0175956dcee86ff96a6904fe59eddeab', 2200, 'admin', NULL, '2024-03-31 19:06:04', NULL);
INSERT INTO `sys_file` VALUES (54, 'QQ截图20230907095049.png', '7ea2dc2d-516b-4e2b-a683-4a2f82d7c626QQ截图20230907095049.png', 'D:\\admin\\file\\7ea2dc2d-516b-4e2b-a683-4a2f82d7c626QQ截图20230907095049.png', '/static/file/7ea2dc2d-516b-4e2b-a683-4a2f82d7c626QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 19:06:10', NULL);
INSERT INTO `sys_file` VALUES (55, 'QQ截图20230907095049.png', 'c2e703e8-5a17-4bc5-85bb-a77a711c2b8bQQ截图20230907095049.png', 'D:\\admin\\file\\c2e703e8-5a17-4bc5-85bb-a77a711c2b8bQQ截图20230907095049.png', '/static/file/c2e703e8-5a17-4bc5-85bb-a77a711c2b8bQQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 19:49:13', NULL);
INSERT INTO `sys_file` VALUES (56, '多人审批.svg', 'e53d3f1a-a4c1-4313-a7cf-99233edb3857多人审批.svg', 'D:\\admin\\file\\e53d3f1a-a4c1-4313-a7cf-99233edb3857多人审批.svg', '/static/file/e53d3f1a-a4c1-4313-a7cf-99233edb3857多人审批.svg', '.svg', 'other', '4bff4ed2715366bd12824bdd9b5d11a2', 2391, 'admin', NULL, '2024-03-31 20:02:20', NULL);
INSERT INTO `sys_file` VALUES (57, 'QQ截图20230907095049.png', 'a19c69bf-5ccc-4c80-9443-80e14da61a22QQ截图20230907095049.png', 'D:\\admin\\file\\a19c69bf-5ccc-4c80-9443-80e14da61a22QQ截图20230907095049.png', '/static/file/a19c69bf-5ccc-4c80-9443-80e14da61a22QQ截图20230907095049.png', '.png', 'other', 'f192159e5952a683a3bd30e6ef77193b', 69047, 'admin', NULL, '2024-03-31 20:07:26', NULL);
INSERT INTO `sys_file` VALUES (58, '测试流程.bpmn20 (1).xml', '549a97b5-7ddf-4f57-876f-db0fb2c8ae03测试流程.bpmn20 (1).xml', 'D:\\admin\\file\\549a97b5-7ddf-4f57-876f-db0fb2c8ae03测试流程.bpmn20 (1).xml', '/static/file/549a97b5-7ddf-4f57-876f-db0fb2c8ae03测试流程.bpmn20 (1).xml', '.xml', 'other', '9b3b3d5bd3a6a49df64355cea2b80adb', 7214, 'admin', NULL, '2024-03-31 21:35:25', NULL);
INSERT INTO `sys_file` VALUES (59, 'squint-smile.svg', 'd7dfbd1e-0d76-4ec8-8da3-fd1ad8ea5c53squint-smile.svg', 'D:\\admin\\file\\d7dfbd1e-0d76-4ec8-8da3-fd1ad8ea5c53squint-smile.svg', '/static/file/d7dfbd1e-0d76-4ec8-8da3-fd1ad8ea5c53squint-smile.svg', '.svg', 'other', '0175956dcee86ff96a6904fe59eddeab', 2200, 'admin', NULL, '2024-03-31 21:36:46', NULL);
INSERT INTO `sys_file` VALUES (60, 'tro.zip', 'b96ea3ea-bac9-42c8-8fa8-5d8117c34a63tro.zip', 'D:\\admin\\file\\b96ea3ea-bac9-42c8-8fa8-5d8117c34a63tro.zip', '/static/file/b96ea3ea-bac9-42c8-8fa8-5d8117c34a63tro.zip', '.zip', 'other', '45e0483db750ace129d363ecfc9369bc', 972, 'admin', NULL, '2024-03-31 21:37:47', NULL);
INSERT INTO `sys_file` VALUES (61, '穿越火线 2024-01-13 14-43-45.mp4', '7d5eb10d-9ab1-407a-aa99-a9017650f7a4穿越火线 2024-01-13 14-43-45.mp4', 'D:\\admin\\file\\7d5eb10d-9ab1-407a-aa99-a9017650f7a4穿越火线 2024-01-13 14-43-45.mp4', '/static/file/7d5eb10d-9ab1-407a-aa99-a9017650f7a4穿越火线 2024-01-13 14-43-45.mp4', '.mp4', 'other', '7405ade100ddaa278c6a5d812192b26c', 6401729, 'admin', NULL, '2024-03-31 21:58:50', NULL);
INSERT INTO `sys_file` VALUES (62, 'ae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '7d9a9327-069d-4cde-9590-a1821694d428ae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', 'D:\\admin\\file\\7d9a9327-069d-4cde-9590-a1821694d428ae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '/static/file/7d9a9327-069d-4cde-9590-a1821694d428ae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '.jpg', 'other', '1bca6bed6a01c11f6a036f453941d958', 25395, 'admin', NULL, '2024-04-01 20:12:14', NULL);
INSERT INTO `sys_file` VALUES (63, 'ae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '8d58c414-ecd5-4c18-ba86-063f1a94e73fae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', 'D:\\admin\\file\\8d58c414-ecd5-4c18-ba86-063f1a94e73fae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '/static/file/8d58c414-ecd5-4c18-ba86-063f1a94e73fae0a5790-a983-48a7-ba3f-d19332018527QRqMK.jpg', '.jpg', 'other', '1bca6bed6a01c11f6a036f453941d958', 25395, 'admin', NULL, '2024-04-01 20:12:46', NULL);
INSERT INTO `sys_file` VALUES (64, 'OIP-C (4).jpg', '10118f6f-7e74-446e-95d2-1d1ea4a1dad6OIP-C (4).jpg', 'D:\\flow\\file\\10118f6f-7e74-446e-95d2-1d1ea4a1dad6OIP-C (4).jpg', '/static/file/10118f6f-7e74-446e-95d2-1d1ea4a1dad6OIP-C (4).jpg', '.jpg', 'other', '0dae1c910e65fc18804c44e6a974442f', 11015, 'admin', NULL, '2024-04-05 13:18:48', NULL);
INSERT INTO `sys_file` VALUES (65, 'signature.png', '2110f21b-6d02-4d77-b73b-dc877a220401signature.png', 'D:\\flow\\file\\2110f21b-6d02-4d77-b73b-dc877a220401signature.png', '/static/file/2110f21b-6d02-4d77-b73b-dc877a220401signature.png', '.png', 'other', 'c28621078754669d112eaa40d60297e8', 41299, 'admin', NULL, '2024-04-20 10:53:56', NULL);
INSERT INTO `sys_file` VALUES (66, 'QRBHS.jpg', 'd48bd069-8cf7-4794-9aa2-1dc9ead2b4faQRBHS.jpg', 'D:\\flow\\file\\d48bd069-8cf7-4794-9aa2-1dc9ead2b4faQRBHS.jpg', '/static/file/d48bd069-8cf7-4794-9aa2-1dc9ead2b4faQRBHS.jpg', '.jpg', 'other', 'f439908ea8858eff7f5a807e6e821930', 27509, 'admin', NULL, '2024-04-27 10:10:51', NULL);
INSERT INTO `sys_file` VALUES (67, 'QRBHS.jpg', 'af0ce8a2-dba5-4b4a-a6aa-20819f51fb2bQRBHS.jpg', 'D:\\flow\\file\\af0ce8a2-dba5-4b4a-a6aa-20819f51fb2bQRBHS.jpg', '/static/file/af0ce8a2-dba5-4b4a-a6aa-20819f51fb2bQRBHS.jpg', '.jpg', 'other', 'f439908ea8858eff7f5a807e6e821930', 27509, 'admin', NULL, '2024-04-27 12:12:46', NULL);
INSERT INTO `sys_file` VALUES (68, 'OIP-C (8).jpg', '0f7fe860-f5a8-4e01-a920-458f4ee7ba4eOIP-C (8).jpg', 'D:\\flow\\file\\0f7fe860-f5a8-4e01-a920-458f4ee7ba4eOIP-C (8).jpg', '/static/file/0f7fe860-f5a8-4e01-a920-458f4ee7ba4eOIP-C (8).jpg', '.jpg', 'other', '5a15dc611e0098ff878da8e7a93df5be', 8609, 'admin', NULL, '2024-04-27 12:23:45', NULL);
INSERT INTO `sys_file` VALUES (69, 'OIP-C (9).jpg', '873cfd2f-1667-48ce-989d-9b7a45e0ffb5OIP-C (9).jpg', 'D:\\flow\\file\\873cfd2f-1667-48ce-989d-9b7a45e0ffb5OIP-C (9).jpg', '/static/file/873cfd2f-1667-48ce-989d-9b7a45e0ffb5OIP-C (9).jpg', '.jpg', 'other', 'c0111c9bdb30048e5e7f27a0846329e0', 7780, 'admin', NULL, '2024-04-27 18:22:59', NULL);
INSERT INTO `sys_file` VALUES (70, 'OIP-C.jpg', '0c903505-edfc-4d81-a730-d1faed31eb5fOIP-C.jpg', 'D:\\flow\\file\\0c903505-edfc-4d81-a730-d1faed31eb5fOIP-C.jpg', '/static/file/0c903505-edfc-4d81-a730-d1faed31eb5fOIP-C.jpg', '.jpg', 'other', 'adeab545afed5c5451f3b8e100a0b422', 6673, 'admin', NULL, '2024-04-29 21:10:16', NULL);
INSERT INTO `sys_file` VALUES (71, 'OIP-C (5).jpg', '4c9d9ea1-8bab-48af-b655-082444259a0fOIP-C (5).jpg', 'D:\\flow\\file\\4c9d9ea1-8bab-48af-b655-082444259a0fOIP-C (5).jpg', '/static/file/4c9d9ea1-8bab-48af-b655-082444259a0fOIP-C (5).jpg', '.jpg', 'other', '1ad8df35ee995c9b5bf03eee75aa6401', 6878, 'admin', NULL, '2024-05-01 13:06:40', NULL);
INSERT INTO `sys_file` VALUES (72, 'OIP-C (3).jpg', '41819b86-956a-47d8-a5bc-979d10107279OIP-C (3).jpg', 'D:\\flow\\file\\41819b86-956a-47d8-a5bc-979d10107279OIP-C (3).jpg', '/static/file/41819b86-956a-47d8-a5bc-979d10107279OIP-C (3).jpg', '.jpg', 'other', '7f29fa8dd0fd316b28cbdff58570cecd', 6901, 'admin', NULL, '2024-05-01 13:10:07', NULL);
INSERT INTO `sys_file` VALUES (73, 'OIP-C (5).jpg', '146bbf68-eb44-424b-9359-8efd9c4596fbOIP-C (5).jpg', 'D:\\flow\\file\\146bbf68-eb44-424b-9359-8efd9c4596fbOIP-C (5).jpg', '/static/file/146bbf68-eb44-424b-9359-8efd9c4596fbOIP-C (5).jpg', '.jpg', 'other', '1ad8df35ee995c9b5bf03eee75aa6401', 6878, 'liyuzhen', NULL, '2024-05-09 21:12:24', NULL);
INSERT INTO `sys_file` VALUES (74, 'signature.png', '8aef9555-97d0-4bd8-a4a2-e48529ef86efsignature.png', 'D:\\flow\\file\\8aef9555-97d0-4bd8-a4a2-e48529ef86efsignature.png', '/static/file/8aef9555-97d0-4bd8-a4a2-e48529ef86efsignature.png', '.png', 'other', 'd58a996924b5c6cf8765f3a8ddfc2714', 24166, 'liyuzhen', NULL, '2024-05-18 22:55:52', NULL);
INSERT INTO `sys_file` VALUES (75, '审批超时.bpmn20 (3).xml', '9c5a3ebf-7613-402e-9ccc-753fe6f9166c审批超时.bpmn20 (3).xml', 'D:\\flow\\file\\9c5a3ebf-7613-402e-9ccc-753fe6f9166c审批超时.bpmn20 (3).xml', '/static/file/9c5a3ebf-7613-402e-9ccc-753fe6f9166c审批超时.bpmn20 (3).xml', '.xml', 'other', 'af4532ef9fbf6e90db6a10b850d7ffd4', 3537, 'liyuzhen', NULL, '2024-06-07 19:39:35', NULL);
INSERT INTO `sys_file` VALUES (76, '审批超时.bpmn20 (1).xml', '2027419e-fb44-431a-9126-4c8311ef9781审批超时.bpmn20 (1).xml', 'D:\\flow\\file\\2027419e-fb44-431a-9126-4c8311ef9781审批超时.bpmn20 (1).xml', '/static/file/2027419e-fb44-431a-9126-4c8311ef9781审批超时.bpmn20 (1).xml', '.xml', 'other', '3be4c897858f83918ed0baa4ed737f1e', 3533, 'liyuzhen', NULL, '2024-06-07 20:10:07', NULL);
INSERT INTO `sys_file` VALUES (77, '审批超时.bpmn20 (2).xml', '41cde182-5b22-419e-8f62-2ec557f31af1审批超时.bpmn20 (2).xml', 'D:\\flow\\file\\41cde182-5b22-419e-8f62-2ec557f31af1审批超时.bpmn20 (2).xml', '/static/file/41cde182-5b22-419e-8f62-2ec557f31af1审批超时.bpmn20 (2).xml', '.xml', 'other', 'f2ecd532d6cb583043c5267bc7bdcbe0', 3528, 'liyuzhen', NULL, '2024-06-07 20:30:10', NULL);
INSERT INTO `sys_file` VALUES (78, '离职申请.bpmn20.xml', '1be9e20b-6b82-4c04-94df-69ff535e0029离职申请.bpmn20.xml', 'D:\\flow\\file\\1be9e20b-6b82-4c04-94df-69ff535e0029离职申请.bpmn20.xml', '/static/file/1be9e20b-6b82-4c04-94df-69ff535e0029离职申请.bpmn20.xml', '.xml', 'other', '295dc5a7b353fd59019d41ff206dc4bc', 6474, 'liyuzhen', NULL, '2024-06-07 20:41:38', NULL);
INSERT INTO `sys_file` VALUES (79, '离职申请.bpmn20.xml', '05cd063c-e6f2-42ca-a246-345d90e9c82e离职申请.bpmn20.xml', 'D:\\flow\\file\\05cd063c-e6f2-42ca-a246-345d90e9c82e离职申请.bpmn20.xml', '/static/file/05cd063c-e6f2-42ca-a246-345d90e9c82e离职申请.bpmn20.xml', '.xml', 'other', '295dc5a7b353fd59019d41ff206dc4bc', 6474, 'liyuzhen', NULL, '2024-06-07 21:06:38', NULL);
INSERT INTO `sys_file` VALUES (80, '测试流程.xml', 'e794fdbd-1190-474d-8039-f4c77efa907c测试流程.xml', 'D:\\flow\\file\\e794fdbd-1190-474d-8039-f4c77efa907c测试流程.xml', '/static/file/e794fdbd-1190-474d-8039-f4c77efa907c测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 12:32:13', NULL);
INSERT INTO `sys_file` VALUES (81, '测试流程.xml', '1e903b71-2e7b-48e3-87ab-416a294e968c测试流程.xml', 'D:\\flow\\file\\1e903b71-2e7b-48e3-87ab-416a294e968c测试流程.xml', '/static/file/1e903b71-2e7b-48e3-87ab-416a294e968c测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 12:35:15', NULL);
INSERT INTO `sys_file` VALUES (82, '离职申请.bpmn20.xml', 'bc4861a5-9e5a-4dc4-a66e-08ef51aed61a离职申请.bpmn20.xml', 'D:\\flow\\file\\bc4861a5-9e5a-4dc4-a66e-08ef51aed61a离职申请.bpmn20.xml', '/static/file/bc4861a5-9e5a-4dc4-a66e-08ef51aed61a离职申请.bpmn20.xml', '.xml', 'other', '295dc5a7b353fd59019d41ff206dc4bc', 6474, 'liyuzhen', NULL, '2024-06-08 15:20:03', NULL);
INSERT INTO `sys_file` VALUES (83, '测试流程.xml', '6d460a34-da57-440b-b66e-5ad8062e5744测试流程.xml', 'D:\\flow\\file\\6d460a34-da57-440b-b66e-5ad8062e5744测试流程.xml', '/static/file/6d460a34-da57-440b-b66e-5ad8062e5744测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 15:22:14', NULL);
INSERT INTO `sys_file` VALUES (84, '测试流程.xml', '2cc1349c-6834-4c52-90de-d806ebcda546测试流程.xml', 'D:\\flow\\file\\2cc1349c-6834-4c52-90de-d806ebcda546测试流程.xml', '/static/file/2cc1349c-6834-4c52-90de-d806ebcda546测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 15:26:41', NULL);
INSERT INTO `sys_file` VALUES (85, '测试流程.xml', '465753e5-dc77-475b-a9ed-a4dda4264ec9测试流程.xml', 'D:\\flow\\file\\465753e5-dc77-475b-a9ed-a4dda4264ec9测试流程.xml', '/static/file/465753e5-dc77-475b-a9ed-a4dda4264ec9测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 15:38:19', NULL);
INSERT INTO `sys_file` VALUES (86, '测试流程.xml', '0e59e402-965d-4174-96f2-081ef83e8c7c测试流程.xml', 'D:\\flow\\file\\0e59e402-965d-4174-96f2-081ef83e8c7c测试流程.xml', '/static/file/0e59e402-965d-4174-96f2-081ef83e8c7c测试流程.xml', '.xml', 'other', '23fc56a21c98fbc005774409217a1fb1', 1971, 'liyuzhen', NULL, '2024-06-08 15:40:30', NULL);

-- ----------------------------
-- Table structure for sys_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_menu`;
CREATE TABLE `sys_menu`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `pid` bigint UNSIGNED NOT NULL DEFAULT 0 COMMENT '上级菜单ID',
  `type` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '菜单类型（0：目录、1：菜单、2：按钮）',
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '路由名称',
  `sort` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '排序',
  `path` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '路径',
  `component` varchar(150) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '组件路径',
  `redirect` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '重定向地址',
  `title` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '标题',
  `icon` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '图标',
  `keep_alive` tinyint UNSIGNED NULL DEFAULT NULL COMMENT '缓存',
  `hidden` tinyint UNSIGNED NULL DEFAULT NULL COMMENT '隐藏',
  `affix` tinyint UNSIGNED NULL DEFAULT NULL COMMENT '固定',
  `active_menu` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '活动菜单',
  `permission` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '权限标识符',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1719011859289968648 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci COMMENT = '菜单' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_menu
-- ----------------------------
INSERT INTO `sys_menu` VALUES (1503734603045699586, 0, 0, 'system', 0, '/system', NULL, '/system/user', '系统管理', 'el:Tools', 0, 0, 0, NULL, NULL, '1356976230017601538', 'admin', '2022-03-15 14:07:22', '2023-10-10 11:06:44');
INSERT INTO `sys_menu` VALUES (1504096722349985794, 1503734603045699586, 1, 'menu', 2, '/system/menu', 'system/menu/index', NULL, '菜单管理', 'el:Menu', 1, 0, 0, NULL, NULL, '1356976230017601538', 'admin', '2022-03-16 14:06:18', '2023-08-23 15:57:26');
INSERT INTO `sys_menu` VALUES (1691804508017930242, 0, 0, 'tool', 3, '/tool', NULL, '', '常用组件', 'vite', 0, 1, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:30:02', '2024-03-09 14:30:47');
INSERT INTO `sys_menu` VALUES (1691805323340296193, 1691804508017930242, 1, 'echarts', 999, '/tool/echarts', 'tools/echarts/index', NULL, 'echarts图表', 'el:ChromeFilled', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:33:16', '2023-08-17 20:21:41');
INSERT INTO `sys_menu` VALUES (1691807004912267266, 1691804508017930242, 1, 'wangeditor', 999, '/tool/wangeditor', 'tools/wangeditor/index', NULL, '富文本', 'el:Document', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:30:02', '2023-08-25 09:18:00');
INSERT INTO `sys_menu` VALUES (1691807701766516738, 1691804508017930242, 1, 'baiduMap', 999, '/tool/baiduMap', 'tools/baiduMap/index', NULL, '百度地图', 'el:MapLocation', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:42:43', '2023-08-16 21:43:08');
INSERT INTO `sys_menu` VALUES (1691808141451210753, 1691804508017930242, 1, 'driver', 999, '/tool/driver', 'tools/driver/index', NULL, '引导页', 'size', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:44:28', '2023-08-21 11:07:47');
INSERT INTO `sys_menu` VALUES (1691808471127699458, 1691804508017930242, 1, 'tableSelect', 999, '/tool/tableSelect', 'tools/tableSelect/index', NULL, '表格选择器', 'el:Calendar', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:45:46', '2023-08-16 21:46:01');
INSERT INTO `sys_menu` VALUES (1691808842160025601, 1691804508017930242, 1, 'cropper', 999, '/tool/cropper', 'tools/cropper/index', NULL, '图片剪裁', 'el:Crop', 1, 0, 0, NULL, NULL, 'admin', NULL, '2023-08-16 21:45:46', NULL);
INSERT INTO `sys_menu` VALUES (1691809070145613826, 1691804508017930242, 1, 'noticeBar', 999, '/tool/noticeBar', 'tools/noticeBar/index', NULL, '通知栏', 'announcement', 1, 0, 0, NULL, NULL, 'admin', NULL, '2023-08-16 21:48:09', NULL);
INSERT INTO `sys_menu` VALUES (1691809238173626370, 1691804508017930242, 1, 'signature', 999, '/tool/signature', 'tools/signature/index', NULL, '签名', 'el:EditPen', 1, 0, 0, NULL, NULL, 'admin', NULL, '2023-08-16 21:48:49', NULL);
INSERT INTO `sys_menu` VALUES (1691809637727219714, 1691804508017930242, 1, 'filterDemo', 999, '/tool/filter', 'tools/filter/index', NULL, '高级筛选', 'el:Pointer', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:50:25', '2023-08-17 22:18:33');
INSERT INTO `sys_menu` VALUES (1691809827611750402, 1691804508017930242, 1, 'formDesign', 999, '/tool/formDesign', 'tools/formDesign/index', NULL, '表单设计器', 'el:DocumentRemove', 1, 1, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:51:10', '2023-10-06 22:42:26');
INSERT INTO `sys_menu` VALUES (1691809987955798018, 1691804508017930242, 1, 'processDesign', 999, '/tool/processDesign', 'tools/processDesign/index', NULL, '流程设计器', 'el:Guide', 1, 1, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:51:48', '2023-10-06 22:42:23');
INSERT INTO `sys_menu` VALUES (1692910220429234177, 1691804508017930242, 1, 'Segmented', 999, '/tool/segmented', 'tools/segmented/index', NULL, '分段器', 'el:Box', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-19 22:43:44', '2023-08-21 13:33:00');
INSERT INTO `sys_menu` VALUES (1693455825024659457, 1503734603045699586, 1, 'org', 1, '/system/org', 'system/dept/index', NULL, '组织管理', 'el:School', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-21 10:51:46', '2024-04-19 18:09:13');
INSERT INTO `sys_menu` VALUES (1693456041102618626, 1503734603045699586, 1, 'user', 0, '/system/user', 'system/user/index', NULL, '用户管理', 'el:User', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695693169157025794, 1503734603045699586, 1, 'dict', 4, '/system/dict', 'system/dict/index', NULL, '数据字典', 'el:Coin', 1, 0, 0, NULL, NULL, 'admin', NULL, '2023-08-27 15:02:11', NULL);
INSERT INTO `sys_menu` VALUES (1695693439907737601, 1503734603045699586, 1, 'role', 3, '/system/role', 'system/role/index', NULL, '角色管理', 'el:UserFilled', 1, 0, 0, NULL, NULL, 'admin', NULL, '2023-08-27 15:03:15', NULL);
INSERT INTO `sys_menu` VALUES (1695988578345627650, 1693456041102618626, 2, NULL, 0, NULL, NULL, NULL, '删除', NULL, 0, 0, 0, NULL, 'user:del', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695988781563850754, 1693456041102618626, 2, NULL, 1, NULL, NULL, NULL, '编辑', NULL, 0, 0, 0, NULL, 'user:edit', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695988916507193345, 1693456041102618626, 2, NULL, 2, NULL, NULL, NULL, '重置密码', NULL, 0, 0, 0, NULL, 'user:resetPwd', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989155200839682, 1693455825024659457, 2, NULL, 0, NULL, NULL, NULL, '编辑', NULL, 0, 0, 0, NULL, 'dept:edit', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989229754593281, 1693455825024659457, 2, NULL, 1, NULL, NULL, NULL, '删除', NULL, 0, 0, 0, NULL, 'dept:del', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989380925698050, 1504096722349985794, 2, NULL, 0, NULL, NULL, NULL, '编辑', NULL, 0, 0, 0, NULL, 'menu:edit', 'admin', 'admin', '2023-08-21 10:52:38', '2024-05-22 22:23:11');
INSERT INTO `sys_menu` VALUES (1695989447397027841, 1504096722349985794, 2, NULL, 1, NULL, NULL, NULL, '删除', NULL, 0, 0, 0, NULL, 'menu:del', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989603978784770, 1695693439907737601, 2, NULL, 0, NULL, NULL, NULL, '编辑', NULL, 0, 0, 0, NULL, 'role:edit', 'admin', 'admin', '2023-08-21 10:52:38', '2024-05-22 22:16:52');
INSERT INTO `sys_menu` VALUES (1695989665383395330, 1695693439907737601, 2, NULL, 1, NULL, NULL, NULL, '删除', NULL, 0, 0, 0, NULL, 'role:del', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989809222856705, 1695693169157025794, 2, NULL, 0, NULL, NULL, NULL, '编辑', NULL, 0, 0, 0, NULL, 'dict:edit', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1695989885240422402, 1695693169157025794, 2, NULL, 1, NULL, NULL, NULL, '删除', NULL, 0, 0, 0, NULL, 'dict:del', 'admin', 'admin', '2023-08-21 10:52:38', '2023-08-25 09:19:34');
INSERT INTO `sys_menu` VALUES (1698578500009144321, 1693456041102618626, 2, NULL, 999, NULL, NULL, NULL, '文件上传', NULL, 0, 0, 0, NULL, 'storage:upload', 'admin', NULL, '2023-09-04 14:07:27', NULL);
INSERT INTO `sys_menu` VALUES (1704313720096239617, 1691804508017930242, 1, 'flowDesign', 999, '/tool/flowDesign', 'tools/flowDesign/index', NULL, '流程设计', 'component', 1, 1, 0, NULL, NULL, 'admin', 'admin', '2023-09-20 09:57:10', '2023-10-06 22:42:30');
INSERT INTO `sys_menu` VALUES (1707618131277631489, 0, 0, 'flow', 1, '/flow', NULL, '/flow/model', '流程管理', 'org', 0, 0, 0, NULL, NULL, 'admin', 'admin', '2023-09-29 12:47:43', '2023-09-29 12:47:58');
INSERT INTO `sys_menu` VALUES (1707619093492912130, 1707618131277631489, 1, 'Model', 1, '/flow/model', 'flow/model/index', NULL, '流程模型', 'el:GoodsFilled', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-08-16 21:30:02', '2024-03-28 20:51:53');
INSERT INTO `sys_menu` VALUES (1711931297412202497, 1713025685109346306, 1, 'Define', 0, '/flow/define', 'flow/define/index', NULL, '发起流程', 'el:List', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-11 10:26:42', '2024-03-28 20:51:20');
INSERT INTO `sys_menu` VALUES (1713025685109346306, 0, 0, 'task', 2, '/task', NULL, '/flow/define', '我的事务', 'el:UserFilled', 0, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-14 10:55:24', '2024-03-30 17:58:01');
INSERT INTO `sys_menu` VALUES (1713026381678383105, 1713025685109346306, 1, 'todo', 1, '/flow/todo', 'flow/todo/index', NULL, '我的代办', 'component', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-14 10:58:11', '2023-10-14 13:39:09');
INSERT INTO `sys_menu` VALUES (1713029617319677954, 1713025685109346306, 1, 'done', 2, '/flow/done', 'flow/done/index', NULL, '已办任务', 'valid-code', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-14 11:11:02', '2023-10-14 13:39:19');
INSERT INTO `sys_menu` VALUES (1716830110782373884, 0, 1, 'filmVideo', 3, '/tools/filmVideo', 'tools/filmVideo/index', NULL, '影视', 'org', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-24 22:52:50', '2024-03-30 15:03:17');
INSERT INTO `sys_menu` VALUES (1716830110782373886, 1713025685109346306, 1, 'Cc', 4, '/flow/cc', 'flow/cc/index', NULL, '抄送我的', 'el:Promotion', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-24 22:52:50', '2024-03-30 15:03:17');
INSERT INTO `sys_menu` VALUES (1716830110782373889, 1713025685109346306, 1, 'Instance', 3, '/flow/instance', 'flow/instance/index', NULL, '我发起的', 'org', 1, 0, 0, NULL, NULL, 'admin', 'admin', '2023-10-24 22:52:50', '2024-03-30 15:03:17');
INSERT INTO `sys_menu` VALUES (1719011859289968643, 1504096722349985794, 2, '', 99, '', '', '', '添加', '', 0, 0, 0, '', 'menu:add', 'admin', 'admin', '2024-05-22 22:25:02', '2024-05-22 22:25:15');
INSERT INTO `sys_menu` VALUES (1719011859289968644, 1693455825024659457, 2, '', 99, '', '', '', '添加', '', 0, 0, 0, '', 'dept:add', 'admin', NULL, '2024-05-22 22:25:31', NULL);
INSERT INTO `sys_menu` VALUES (1719011859289968645, 1695693439907737601, 2, '', 99, '', '', '', '添加', '', 0, 0, 0, '', 'role:add', 'admin', NULL, '2024-05-22 22:25:50', NULL);
INSERT INTO `sys_menu` VALUES (1719011859289968646, 1695693169157025794, 2, '', 99, '', '', '', '添加', '', 0, 0, 0, '', 'dict:add', 'admin', NULL, '2024-05-22 22:26:03', NULL);
INSERT INTO `sys_menu` VALUES (1719011859289968647, 1693456041102618626, 2, '', 99, '', '', '', '添加', '', 0, 0, 0, '', 'user:add', 'admin', NULL, '2024-05-22 22:26:25', NULL);

-- ----------------------------
-- Table structure for sys_notify
-- ----------------------------
DROP TABLE IF EXISTS `sys_notify`;
CREATE TABLE `sys_notify`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `subject` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '主题',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '内容',
  `sender` varchar(40) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '发送者',
  `receiver` varchar(40) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '接收者',
  `type` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '类型',
  `receiving_time` datetime NOT NULL COMMENT '接收时间',
  `is_read` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否已读',
  `archived` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否归档',
  `url` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '跳转url',
  `params` json NULL COMMENT '跳转参数',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1153 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_notify
-- ----------------------------
INSERT INTO `sys_notify` VALUES (1, '您申请的流程已通过', '您申请的流程null已通过', 'admin', 'liyuzhen', 'system', '2024-05-02 23:54:11', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (2, '您申请的流程已通过', '您申请的流程加班申请已通过', 'admin', 'liyuzhen', 'system', '2024-05-02 23:55:49', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (3, '您申请的流程已通过', '您申请的流程加班申请已通过', 'admin', 'admin', 'system', '2024-05-03 09:31:23', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (4, '您有新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:47:35', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (5, '您有新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:47:35', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (6, '您有新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:47:46', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (7, '您有新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:47:46', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (8, '您有新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 09:47:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (9, '您有新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 09:47:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (10, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 09:49:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (11, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 09:49:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (12, '您申请的流程已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 09:49:19', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (13, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:49:32', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (14, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:49:32', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (15, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:49:44', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (16, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:49:44', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (17, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 09:50:05', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (18, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 09:50:05', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (19, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 09:50:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (20, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 09:50:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (21, '您申请的流程已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 09:50:29', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (22, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:50:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (23, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:50:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (24, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:50:45', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (25, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:50:45', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (26, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 09:50:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (27, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 09:50:50', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (28, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 09:51:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (29, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 09:51:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (30, '您申请的流程已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 09:51:11', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (31, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:54:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (32, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:54:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (33, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 09:54:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (34, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 09:54:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (35, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 09:55:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (36, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 09:55:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (37, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 09:55:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (38, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 09:55:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (39, '您申请的流程已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 10:07:10', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (40, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 10:07:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (41, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 10:07:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (42, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 10:09:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (43, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 10:09:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (44, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 10:09:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (45, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 10:09:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (46, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 10:14:45', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (47, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 10:14:45', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (48, '您申请的流程已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 10:15:13', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (49, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 10:15:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (50, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 10:15:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (51, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 10:22:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (52, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 10:22:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (53, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 11:27:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (54, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 11:27:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (55, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 11:27:11', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (56, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 11:27:11', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (57, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 11:28:53', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (58, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:29:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (59, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:29:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (60, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 11:29:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (61, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 11:29:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (62, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 11:31:41', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (63, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 11:31:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (64, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 11:31:59', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (65, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:32:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (66, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:32:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (67, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:33:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (68, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:33:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (69, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:35:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (70, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:35:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (71, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 11:36:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (72, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 11:36:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (73, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 11:40:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (74, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 11:40:53', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (75, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 11:42:13', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (76, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:43:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (77, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:44:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (78, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:46:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (79, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:46:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (80, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 11:55:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (81, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 11:55:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (82, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 11:55:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (83, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 11:55:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (84, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:03:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (85, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:03:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (86, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 12:04:00', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (87, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:04:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (88, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:04:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (89, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:04:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (90, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:04:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (91, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:04:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (92, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:04:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (93, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 12:06:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (94, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 12:06:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (95, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:08:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (96, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:08:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (97, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 12:09:09', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (98, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:10:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (99, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:10:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (100, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:10:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (101, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:10:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (102, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:10:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (103, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:10:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (104, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:10:53', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (105, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:10:53', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (106, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:11:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (107, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:11:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (108, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 12:12:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (109, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 12:12:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (110, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:12:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (111, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:12:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (112, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 12:37:45', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (113, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:37:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (114, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:37:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (115, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 12:38:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (116, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 12:38:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (117, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:38:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (118, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:38:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (119, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 12:41:43', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (120, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:41:55', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (121, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:41:55', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (122, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:43:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (123, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:43:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (124, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:43:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (125, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:43:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (126, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 12:45:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (127, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 12:45:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (128, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:45:15', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (129, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:45:15', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (130, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 12:45:25', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (131, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:45:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (132, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:45:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (133, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:45:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (134, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:45:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (135, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 12:45:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (136, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 12:45:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (137, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 12:45:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (138, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 12:45:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (139, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 12:46:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (140, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 12:46:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (141, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'liyuzhen', 'system', '2024-05-03 12:46:13', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (151, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:28:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (152, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:28:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (153, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:28:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (154, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:28:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (155, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:28:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (156, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:28:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (158, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:31:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (159, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:31:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (160, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 13:32:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (161, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 13:32:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (162, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 13:33:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (163, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 13:33:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (164, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 13:34:28', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (165, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:34:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (166, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:34:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (167, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:34:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (168, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:34:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (176, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 13:50:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (177, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 13:50:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (178, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 13:51:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (179, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 13:51:55', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (180, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 13:55:05', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (181, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:55:25', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (182, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:55:28', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (183, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:55:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (184, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:55:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (185, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 13:57:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (186, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 13:57:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (187, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 13:57:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (188, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 13:57:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (189, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 14:01:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (191, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 14:19:56', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (192, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:20:26', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (193, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:20:29', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (194, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:22:26', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (195, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:22:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (196, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:23:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (197, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:23:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (198, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 14:23:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (199, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 14:23:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (200, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 14:24:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (201, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 14:24:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (202, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 14:25:57', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (203, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:28:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (204, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:28:13', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (205, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:28:27', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (206, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:28:27', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (212, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:35:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (213, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:35:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (214, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-03 14:35:43', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (215, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-03 14:35:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (216, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-03 14:38:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (217, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-03 14:39:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (218, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-03 14:39:59', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (219, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:40:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (220, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'system', '2024-05-03 14:40:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (221, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'system', '2024-05-03 14:41:41', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (222, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:41:41', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (223, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-03 14:41:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (224, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:41:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (225, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-03 14:43:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (226, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:43:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (227, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'todo', '2024-05-03 14:44:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (228, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:44:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (229, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-03 14:45:29', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (230, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:45:29', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (231, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-03 14:45:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (232, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-03 14:45:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (233, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-05 15:14:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (234, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-05 15:14:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (235, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'admin', 'todo', '2024-05-05 15:15:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (236, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'admin', 'todo', '2024-05-05 15:15:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (237, '新的审批任务', '您有新的审批任务《嵌套并行审批人1》', 'admin', 'admin', 'todo', '2024-05-05 15:15:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (238, '新的审批任务', '您有新的审批任务《嵌套并行审批人2》', 'admin', 'admin', 'todo', '2024-05-05 15:15:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (239, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'todo', '2024-05-05 15:15:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (240, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'todo', '2024-05-05 15:15:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (241, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'todo', '2024-05-05 15:15:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (242, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'todo', '2024-05-05 15:15:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (243, '申请已通过', '您申请的流程《加班申请》已通过', 'admin', 'liyuzhen', 'system', '2024-05-05 15:17:40', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (248, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-1》', 'admin', 'admin', 'system', '2024-05-06 13:19:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (249, '新的审批任务', '您有新的审批任务《嵌套并行审批人2-2》', 'admin', 'admin', 'system', '2024-05-06 13:19:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (250, '新的审批任务', '您有新的审批任务《并行聚集审批1》', 'admin', 'admin', 'system', '2024-05-06 13:19:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (251, '新的审批任务', '您有新的审批任务《并行聚集审批2》', 'admin', 'admin', 'system', '2024-05-06 13:19:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (252, '申请已通过申请已通过申请已通过申请已通过申请已通过申请已通过申请已通过申请已通过', '您申请的流程《加班申请》已通过，您申请的流程《加班申请》已通过，您申请的流程《加班申请》已通过', 'admin', 'admin', 'system', '2024-05-06 13:19:48', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (253, '新的审批任务', '您有新的审批任务《开始审批人1》', 'admin', 'admin', 'todo', '2024-05-09 14:21:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (254, '新的审批任务', '您有新的审批任务《开始审批人2》', 'admin', 'admin', 'todo', '2024-05-09 14:21:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (255, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:24:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (256, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:24:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (257, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:24:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (258, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:25:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (259, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:25:30', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (260, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:26:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (261, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:26:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (262, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:26:27', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (263, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:26:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (264, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:26:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (265, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:27:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (266, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:27:10', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (267, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:27:15', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (268, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:27:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (269, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:36:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (270, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:36:18', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (271, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:36:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (272, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:36:53', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (273, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:36:58', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (274, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:37:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (275, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:37:11', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (276, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:37:16', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (277, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:37:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (278, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:37:28', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (279, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:38:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (280, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:39:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (281, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:39:38', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (282, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:40:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (283, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:40:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (284, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:41:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (285, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:41:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (286, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:41:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (287, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:41:36', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (288, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:41:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (289, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (290, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (291, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:42:16', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (292, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:25', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (293, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (294, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (295, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:42:41', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (296, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:42:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (297, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:43:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (298, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:43:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (299, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:43:18', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (300, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:43:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (301, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:44:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (302, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:44:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (303, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:44:15', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (304, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:44:43', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (305, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:44:43', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (306, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (307, '新的审批任务', '您有新的审批任务《条件2审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (308, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (309, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:13', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (310, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (311, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 16:45:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (312, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 16:45:58', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (313, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:06:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (314, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:10:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (315, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:10:22', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (316, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:11:16', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (317, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:11:25', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (318, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:11:43', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (319, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:11:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (320, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 21:12:26', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (321, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:19:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (322, '新的审批任务', '您有新的审批任务《默认审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:19:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (323, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-09 21:19:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (324, '申请已通过', '您申请的流程《包容网关测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-09 21:19:18', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (325, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 16:42:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (326, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:36:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (327, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:36:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (328, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:36:24', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (330, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:37:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (331, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:38:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (332, '新的审批任务', '您有新的审批任务《条件3审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:38:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (333, '新的审批任务', '您有新的审批任务《聚合审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:38:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (334, '申请拒绝', '您申请的流程《包容网关测试》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-16 19:38:12', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (335, '申请已通过', '您申请的流程《并行测试》已通过', 'admin', 'liyuzhen', 'system', '2024-05-16 19:38:17', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (336, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:40:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (337, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:40:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (338, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:40:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (339, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:40:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (340, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:41:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (341, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:41:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (342, '新的审批任务', '您有新的审批任务《并行审批人1.1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:41:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (343, '新的审批任务', '您有新的审批任务《并行审批人1.2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:41:12', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (344, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 19:41:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (345, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:24:45', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (347, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:27:13', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (348, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:27:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (349, '申请拒绝', '您申请的流程《跳转测试》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-16 22:27:37', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (350, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:28:42', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (351, '申请拒绝', '您申请的流程《并行测试》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-16 22:28:52', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (352, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:28:58', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (353, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:28:58', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (354, '新的审批任务', '您有新的审批任务《并行审批人1.1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:29:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (355, '新的审批任务', '您有新的审批任务《并行审批人1.2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:29:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (356, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 22:29:26', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (357, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:14:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (358, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:14:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (359, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:14:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (360, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:14:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (361, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:14:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (362, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:16:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (363, '申请拒绝', '您申请的流程《并行测试》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-16 23:16:30', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (364, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:19:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (365, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:19:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (366, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:19:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (367, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:19:51', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (368, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:28:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (369, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:28:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (370, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:28:18', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (371, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:33:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (372, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:33:50', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (373, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:34:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (374, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:37:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (375, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:37:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (376, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:41:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (377, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:45:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (378, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:45:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (379, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:45:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (380, '新的审批任务', '您有新的审批任务《并行审批人1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:50:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (381, '新的审批任务', '您有新的审批任务《并行审批人2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:50:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (382, '新的审批任务', '您有新的审批任务《并行审批人1.1》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:50:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (383, '新的审批任务', '您有新的审批任务《并行审批人1.2》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:50:14', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (384, '新的审批任务', '您有新的审批任务《开始审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-16 23:52:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (385, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-18 21:18:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (386, '申请拒绝', '您申请的流程《并行测试》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-18 21:19:23', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (387, '申请已通过', '您申请的流程《高级设置》已通过', 'admin', 'liyuzhen', 'system', '2024-05-18 21:22:38', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (388, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-18 21:22:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (389, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-18 22:55:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (390, '申请已通过', '您申请的流程《高级设置》已通过', 'admin', 'liyuzhen', 'system', '2024-05-18 23:02:12', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (391, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'admin', 'todo', '2024-05-22 00:06:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (392, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-22 00:07:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (393, '申请拒绝', '您申请的流程《高级设置》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-22 14:08:29', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (394, '申请拒绝', '您申请的流程《高级设置》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-22 14:08:32', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (395, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'admin', 'todo', '2024-05-22 14:14:00', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (396, '申请已通过', '您申请的流程《计时等待》已通过', 'admin', 'admin', 'system', '2024-05-22 14:15:14', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (397, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'admin', 'todo', '2024-05-22 14:16:34', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (398, '申请拒绝', '您申请的流程《计时等待》已拒绝', 'admin', 'admin', 'system', '2024-05-22 21:54:59', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (399, '申请拒绝', '您申请的流程《计时等待》已拒绝', 'admin', 'admin', 'system', '2024-05-22 21:55:03', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (400, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'admin', 'todo', '2024-05-22 21:55:22', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (401, '申请已通过', '您申请的流程《计时等待》已通过', 'admin', 'admin', 'system', '2024-05-22 21:56:45', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (402, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-24 15:14:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (403, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-24 15:44:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (404, '申请拒绝', '您申请的流程《新建模型6666》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-24 15:44:57', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (405, '申请拒绝', '您申请的流程《新建模型6666》已拒绝', 'admin', 'liyuzhen', 'system', '2024-05-24 15:45:01', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (406, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-24 15:45:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (407, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-27 15:39:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (412, '消息主题：111', '消息内容：111', 'admin', 'admin', 'system', '2024-05-27 15:48:40', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (413, '消息主题：111', '消息内容：111', 'admin', '00000', 'system', '2024-05-27 15:48:40', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (414, '消息主题：111', '消息内容：111', 'admin', 'liyuzhen', 'system', '2024-05-27 15:48:40', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (415, '消息主题：111', '消息内容：111', 'admin', 'caiyan', 'system', '2024-05-27 15:48:40', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (416, '申请已通过', '您申请的流程《消息通知》已通过', 'admin', 'liyuzhen', 'system', '2024-05-27 15:48:43', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (417, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-27 21:58:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (418, '消息主题：{field_o4rgm}', '消息内容：{field_o4rgm}', 'admin', 'admin', 'system', '2024-05-27 21:58:33', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (419, '消息主题：{field_o4rgm}', '消息内容：{field_o4rgm}', 'admin', '00000', 'system', '2024-05-27 21:58:33', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (420, '消息主题：{field_o4rgm}', '消息内容：{field_o4rgm}', 'admin', 'liyuzhen', 'system', '2024-05-27 21:58:33', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (421, '消息主题：{field_o4rgm}', '消息内容：{field_o4rgm}', 'admin', 'caiyan', 'system', '2024-05-27 21:58:33', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (422, '申请已通过', '您申请的流程《消息通知》已通过', 'admin', 'liyuzhen', 'system', '2024-05-27 21:58:35', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (423, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-27 21:59:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (424, '消息主题：1996', '消息内容：1996', 'admin', 'admin', 'system', '2024-05-27 21:59:34', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (425, '消息主题：1996', '消息内容：1996', 'admin', '00000', 'system', '2024-05-27 21:59:34', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (426, '消息主题：1996', '消息内容：1996', 'admin', 'liyuzhen', 'system', '2024-05-27 21:59:34', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (427, '消息主题：1996', '消息内容：1996', 'admin', 'caiyan', 'system', '2024-05-27 21:59:34', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (428, '申请已通过', '您申请的流程《消息通知》已通过', 'admin', 'liyuzhen', 'system', '2024-05-27 21:59:37', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (429, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-05-27 22:01:41', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (430, '消息主题：11', '消息内容：11', 'admin', 'admin', 'system', '2024-05-27 22:01:48', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (431, '消息主题：11', '消息内容：11', 'admin', '00000', 'system', '2024-05-27 22:01:48', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (432, '消息主题：11', '消息内容：11', 'admin', 'liyuzhen', 'system', '2024-05-27 22:01:48', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (433, '消息主题：11', '消息内容：11', 'admin', 'caiyan', 'system', '2024-05-27 22:01:48', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (434, '申请已通过', '您申请的流程《消息通知》已通过', 'admin', 'liyuzhen', 'system', '2024-05-27 22:01:51', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (435, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 22:57:33', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (436, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 22:57:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (437, '申请已通过', '您申请的流程《百分比》已通过', 'admin', 'liyuzhen', 'system', '2024-06-01 22:58:17', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (438, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 23:00:00', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (439, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 23:00:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (440, '申请已通过', '您申请的流程《百分比》已通过', 'admin', 'liyuzhen', 'system', '2024-06-01 23:00:07', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (441, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 23:00:32', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (442, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 23:00:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (443, '申请已通过', '您申请的流程《百分比》已通过', 'admin', 'liyuzhen', 'system', '2024-06-01 23:00:40', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (444, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 23:02:02', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (445, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 23:02:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (446, '申请已通过', '您申请的流程《百分比》已通过', 'admin', 'liyuzhen', 'system', '2024-06-01 23:02:10', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (447, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 23:18:10', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (448, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 23:18:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (449, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'caiyan', 'todo', '2024-06-01 23:32:48', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (450, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-01 23:32:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (451, '申请已通过', '您申请的流程《百分比》已通过', 'admin', 'liyuzhen', 'system', '2024-06-01 23:32:56', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (452, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-03 20:33:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (453, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-03 22:13:19', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (454, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-03 22:13:26', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (455, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-03 22:19:34', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (456, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-03 22:20:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (457, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-03 22:22:01', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (458, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-03 22:40:49', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (459, '审批提醒', '任务【审批人】已超时，请及时审批。', 'admin', 'liyuzhen', 'system', '2024-06-03 22:41:55', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (460, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-03 23:08:26', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (461, '审批提醒', '您的审批任务【审批人】已超分钟1未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-03 23:09:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (462, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 10:04:19', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (463, '审批提醒', '您的审批任务【审批人】已超秒30未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 10:04:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (464, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 11:16:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (465, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:16:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (466, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:17:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (467, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:17:42', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (468, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:18:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (469, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:19:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (470, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:19:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (471, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:20:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (472, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:20:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (473, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:21:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (474, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:21:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (475, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:22:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (476, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:22:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (477, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:23:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (478, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:23:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (479, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:24:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (480, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:24:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (481, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:25:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (482, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:25:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (483, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:37:13', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (484, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:37:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (485, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:38:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (486, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:38:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (487, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:39:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (488, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:39:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (489, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:40:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (490, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:40:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (491, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:41:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (492, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:41:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (493, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:42:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (494, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:42:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (495, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:43:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (496, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:43:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (497, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:44:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (498, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:44:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (499, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:45:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (500, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:45:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (501, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:46:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (502, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:46:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (503, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:47:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (504, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:47:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (505, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:48:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (506, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:48:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (507, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:49:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (508, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:49:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (509, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:50:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (510, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:50:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (511, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:51:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (512, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:51:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (513, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:52:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (514, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:52:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (515, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:53:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (516, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:53:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (517, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:54:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (518, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:54:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (519, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:55:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (520, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:55:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (521, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:56:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (522, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:56:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (523, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:57:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (524, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:57:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (525, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:58:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (526, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:58:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (527, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:59:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (528, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 11:59:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (529, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:00:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (530, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:00:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (531, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:01:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (532, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:01:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (533, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:02:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (534, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:51:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (535, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:52:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (536, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:52:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (537, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:53:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (538, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:53:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (539, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:54:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (540, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:54:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (541, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:55:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (542, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:55:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (543, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:56:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (544, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:56:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (545, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:57:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (546, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:57:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (547, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:58:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (548, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:58:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (549, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:59:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (550, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 12:59:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (551, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:00:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (552, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:00:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (553, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:01:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (554, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:01:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (555, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:02:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (556, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:02:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (557, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:03:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (558, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:03:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (559, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:04:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (560, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:04:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (561, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:05:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (562, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:05:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (563, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:06:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (564, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:06:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (565, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:07:10', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (566, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:07:40', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (567, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:08:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (568, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:08:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (569, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:09:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (570, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:09:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (571, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:10:00', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (572, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:10:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (573, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:11:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (574, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 13:11:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (575, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-04 13:11:44', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (576, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:02:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (577, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:03:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (578, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:04:09', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (579, '申请拒绝', '您申请的流程《审批超时》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-04 17:04:09', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (580, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:04:59', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (581, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:05:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (582, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-04 17:05:21', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (583, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:05:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (584, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:05:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (585, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:05:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (586, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:06:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (587, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:06:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (588, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:06:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (589, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:06:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (590, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:07:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (591, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:07:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (592, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:07:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (593, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:07:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (594, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:08:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (595, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:08:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (596, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:08:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (597, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:08:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (598, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:09:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (599, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:09:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (600, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:09:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (601, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:09:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (602, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:10:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (603, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:10:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (604, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:10:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (605, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:10:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (606, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:11:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (607, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:11:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (608, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:11:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (609, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:11:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (610, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:12:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (611, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:12:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (612, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:12:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (613, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:12:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (614, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:13:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (615, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:13:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (616, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:13:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (617, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:13:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (618, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:14:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (619, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:14:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (620, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:14:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (621, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:14:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (622, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:15:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (623, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:15:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (624, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:15:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (625, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:15:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (626, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:16:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (627, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:16:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (628, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:16:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (629, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:16:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (630, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:18:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (631, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:18:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (632, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:19:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (633, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:19:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (634, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:19:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (635, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:19:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (636, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:20:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (637, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:20:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (638, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:20:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (639, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:20:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (640, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:21:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (641, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:21:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (642, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:21:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (643, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:21:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (644, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:22:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (645, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:22:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (646, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:22:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (647, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:22:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (648, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:23:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (649, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:23:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (650, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:23:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (651, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:23:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (652, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:24:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (653, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:24:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (654, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:24:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (655, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 17:24:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (656, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:43:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (657, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:43:23', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (658, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:43:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (659, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:43:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (660, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:44:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (661, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:44:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (662, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:44:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (663, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:44:33', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (664, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:45:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (665, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:45:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (666, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:45:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (667, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:45:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (668, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:46:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (669, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:46:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (670, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:46:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (671, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:46:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (672, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:47:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (673, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:47:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (674, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:47:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (675, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:47:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (676, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:48:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (677, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:48:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (678, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:48:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (679, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:48:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (680, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:49:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (681, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:49:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (682, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:49:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (683, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:49:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (684, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:50:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (685, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:50:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (686, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:50:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (687, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:50:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (688, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:51:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (689, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:51:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (690, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:51:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (691, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:51:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (692, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:52:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (693, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:52:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (694, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:52:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (695, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:52:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (696, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:53:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (697, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:53:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (698, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:53:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (699, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:53:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (700, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:54:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (701, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:54:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (702, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:54:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (703, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:54:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (704, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:55:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (705, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:55:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (706, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:55:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (707, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:55:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (708, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:56:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (709, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:56:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (710, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:56:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (711, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:56:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (712, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:57:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (713, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:57:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (714, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:57:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (715, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:57:35', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (716, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:58:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (717, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:58:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (718, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:58:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (719, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:58:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (720, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:59:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (721, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:59:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (722, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:59:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (723, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 19:59:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (724, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:00:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (725, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:00:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (726, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:00:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (727, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:00:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (728, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:01:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (729, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:01:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (730, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:01:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (731, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:01:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (732, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:02:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (733, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:02:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (734, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:02:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (735, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:02:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (736, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:03:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (737, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:03:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (738, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:03:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (739, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:03:36', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (740, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:04:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (741, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:04:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (742, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:04:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (743, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:04:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (744, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:05:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (745, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:05:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (746, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:05:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (747, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:05:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (748, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:06:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (749, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:06:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (750, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:06:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (751, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:06:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (752, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:07:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (753, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:07:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (754, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:07:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (755, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:07:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (756, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:08:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (757, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:08:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (758, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:08:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (759, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:08:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (760, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:09:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (761, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:09:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (762, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:09:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (763, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:09:37', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (764, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:10:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (765, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:10:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (766, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:10:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (767, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:10:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (768, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:11:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (769, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:11:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (770, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:11:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (771, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:11:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (772, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:12:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (773, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:12:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (774, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:12:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (775, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:12:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (776, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:13:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (777, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:13:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (778, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:13:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (779, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:13:38', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (780, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:14:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (781, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:14:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (782, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:14:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (783, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:14:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (784, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:15:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (785, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:15:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (786, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:15:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (787, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:15:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (788, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:16:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (789, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:16:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (790, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:16:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (791, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:16:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (792, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:17:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (793, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:17:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (794, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:17:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (795, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:17:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (796, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:18:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (797, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:18:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (798, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:18:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (799, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:18:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (800, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:19:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (801, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:19:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (802, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:19:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (803, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:19:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (804, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:20:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (805, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:20:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (806, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:20:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (807, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:20:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (808, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:21:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (809, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:21:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (810, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:21:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (811, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:21:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (812, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:22:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (813, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:22:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (814, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:22:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (815, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:22:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (816, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:23:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (817, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:23:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (818, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:23:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (819, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:23:32', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (820, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:24:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (821, '审批提醒', '您的审批任务【审批人】已超30秒未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:24:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (822, '申请拒绝', '您申请的流程《审批超时》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-04 20:24:22', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (823, '申请拒绝', '您申请的流程《审批超时》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-04 20:24:29', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (824, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:27:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (825, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:28:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (826, '申请拒绝', '您申请的流程《审批超时》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-04 20:28:35', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (827, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 20:28:52', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (828, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:29:04', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (829, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:30:07', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (830, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:31:30', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (831, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 20:32:06', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (832, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 20:32:39', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (833, '申请拒绝', '您申请的流程《审批超时》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-04 21:23:59', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (834, '申请已通过', '您申请的流程《新建模型6666》已通过', 'admin', 'liyuzhen', 'system', '2024-06-04 22:48:43', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (835, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 22:49:56', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (836, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:51:44', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (837, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:51:58', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (838, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:52:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (839, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:53:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (840, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:54:25', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (841, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 22:54:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (842, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-04 22:55:07', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (843, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 22:55:17', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (844, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 22:55:57', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (845, '申请已通过', '您申请的流程《审批超时》已通过', 'admin', 'liyuzhen', 'system', '2024-06-04 22:56:11', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (846, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 22:57:54', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (847, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:58:08', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (848, '审批提醒', '您的审批任务【审批人】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-04 22:59:31', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (849, '新的审批任务', '您有新的审批任务《审批人》', 'admin', 'liyuzhen', 'todo', '2024-06-04 23:00:29', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (850, '申请已通过', '您申请的流程《同一个测试》已通过', 'admin', 'liyuzhen', 'system', '2024-06-07 17:27:38', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (851, '申请已通过', '您申请的流程《同一个测试》已通过', 'admin', 'liyuzhen', 'system', '2024-06-07 17:29:15', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (852, '新的审批任务', '您有一条待处理的审批任务：审批人，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-07 17:30:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (853, '新的审批任务', '您有一条待处理的审批任务：审批人，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-07 17:37:43', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (854, '新的审批任务', '您有一条待处理的审批任务【直属领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 19:39:48', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (855, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:40:03', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (856, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:41:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (857, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:42:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (858, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:43:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (859, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:44:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (860, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:45:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (861, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:46:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (862, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:47:01', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (863, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 19:59:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (864, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:00:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (865, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:01:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (866, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:02:02', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (867, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-07 20:02:34', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (868, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 20:02:34', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (869, '有人离职了', '在日期：2024-06-07，有人提离职了。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:02:48', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (870, '有人离职了', '在日期：2024-06-07，有人提离职了。', 'admin', 'caiyan', 'system', '2024-06-07 20:02:48', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (871, '申请已通过', '您申请的流程《离职申请》已通过', 'admin', 'liyuzhen', 'system', '2024-06-07 20:03:02', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (872, '新的审批任务', '您有一条待处理的审批任务【直属领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 20:10:20', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (873, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:11:21', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (874, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-07 20:29:05', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (875, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 20:29:05', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (876, '有人离职了', '在日期：2024-06-07，有人提离职了。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:29:17', 1, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (877, '有人离职了', '在日期：2024-06-07，有人提离职了。', 'admin', 'caiyan', 'system', '2024-06-07 20:29:17', 0, 0, NULL, NULL);
INSERT INTO `sys_notify` VALUES (878, '申请已通过', '您申请的流程《离职申请》已通过', 'admin', 'liyuzhen', 'system', '2024-06-07 20:29:20', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (879, '新的审批任务', '您有一条待处理的审批任务【直属领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 20:41:43', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (880, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:42:46', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (881, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:43:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (882, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:44:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (883, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:45:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (884, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:46:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (885, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:47:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (886, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:48:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (887, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:49:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (888, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:50:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (889, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 20:51:47', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (890, '新的审批任务', '您有一条待处理的审批任务【直属领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-07 21:06:50', 1, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (891, '申请拒绝', '您申请的流程《离职申请》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-07 21:07:07', 1, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (892, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 21:07:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (893, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 21:08:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (894, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 21:09:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (895, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-07 21:10:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (896, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:25:20', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (897, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:25:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (898, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:26:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (899, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:27:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (900, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:28:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (901, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:29:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (902, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:30:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (903, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:31:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (904, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-08 12:32:24', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (905, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-08 12:32:24', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (906, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:32:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (907, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:33:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (908, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:34:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (909, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:38:13', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (910, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-08 12:38:13', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (911, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-08 12:38:13', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (912, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:38:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (913, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:39:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (914, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:40:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (915, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:41:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (916, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:42:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (917, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:43:51', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (918, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:44:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (919, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:45:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (920, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:46:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (921, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:47:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (922, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:48:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (923, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:49:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (924, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:50:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (925, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:51:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (926, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:52:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (927, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:53:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (928, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:54:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (929, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:55:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (930, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:56:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (931, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:57:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (932, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:58:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (933, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 12:59:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (934, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:00:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (935, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:01:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (936, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:02:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (937, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:03:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (938, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:04:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (939, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:05:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (940, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:06:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (941, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:07:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (942, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:08:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (943, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:09:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (944, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:10:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (945, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:11:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (946, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:12:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (947, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:13:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (948, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:14:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (949, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:15:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (950, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:16:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (951, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:17:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (952, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:18:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (953, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:19:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (954, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:20:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (955, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:21:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (956, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:22:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (957, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:23:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (958, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:24:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (959, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:25:58', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (960, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:26:58', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (961, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:27:58', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (962, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:28:58', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (963, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:29:58', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (964, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:30:48', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (965, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:31:48', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (966, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:32:48', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (967, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:33:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (968, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:34:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (969, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:35:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (970, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:36:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (971, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:37:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (972, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:38:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (973, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:39:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (974, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:40:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (975, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:41:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (976, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:42:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (977, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:43:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (978, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:44:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (979, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 13:45:50', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (980, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:08:12', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (981, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:08:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (982, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:09:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (983, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:10:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (984, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:11:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (985, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:12:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (986, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:13:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (987, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:14:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (988, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:15:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (989, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:16:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (990, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:17:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (991, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:18:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (992, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:19:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (993, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:20:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (994, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:21:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (995, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:22:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (996, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:23:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (997, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:24:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (998, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:25:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (999, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:26:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1000, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:27:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1001, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:28:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1002, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:29:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1003, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:30:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1004, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:31:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1005, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:32:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1006, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:33:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1007, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:34:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1008, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:35:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1009, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:36:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1010, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:37:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1011, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:38:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1012, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:39:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1013, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:40:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1014, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:41:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1015, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:42:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1016, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:43:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1017, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:44:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1018, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:45:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1019, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:46:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1020, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:47:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1021, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:48:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1022, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:49:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1023, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:50:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1024, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:51:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1025, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:52:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1026, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:54:25', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1027, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:54:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1028, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:55:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1029, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:56:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1030, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:57:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1031, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:58:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1032, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 14:59:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1033, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:00:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1034, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:01:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1035, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:02:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1036, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:03:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1037, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:04:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1038, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:05:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1039, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:06:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1040, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:07:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1041, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:08:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1042, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:09:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1043, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:10:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1044, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:11:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1045, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:12:56', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1046, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:13:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1047, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:14:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1048, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:15:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1049, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:16:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1050, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:17:57', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1051, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:18:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1052, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:19:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1053, '申请拒绝', '您申请的流程《离职申请》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-08 15:20:12', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1054, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:20:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1055, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:21:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1056, '申请拒绝', '您申请的流程《离职申请》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-08 15:22:21', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1057, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:22:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1058, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:23:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1059, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:24:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1060, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:25:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1061, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-08 15:26:46', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1062, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-08 15:26:46', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1063, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:26:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1064, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:27:52', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1065, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:28:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1066, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:29:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1067, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:30:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1068, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:31:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1069, '审批提醒', '您的审批任务【直属领导】已超1分钟未处理，请及时处理。', 'admin', 'liyuzhen', 'system', '2024-06-08 15:32:53', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1070, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-08 15:38:27', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1071, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-08 15:38:27', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1072, '申请拒绝', '您申请的流程《离职申请》已拒绝', 'admin', 'liyuzhen', 'system', '2024-06-08 15:40:22', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1073, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'caiyan', 'todo', '2024-06-08 15:40:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1074, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-08 15:40:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1075, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:15:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1076, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:15:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1077, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:15:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1078, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:15:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1079, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:17:22', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1080, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:17:31', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1081, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:17:31', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1082, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:17:31', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1083, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:17:31', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1084, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:17:45', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1085, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:20:41', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1086, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:20:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1087, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:20:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1088, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:20:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1089, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:20:54', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1090, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:21:34', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1091, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:32:01', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1092, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:32:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1093, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:32:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1094, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:32:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1095, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:32:18', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1096, '申请已通过', '您申请的流程《请假666》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:32:37', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1097, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:48:24', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1098, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:48:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1099, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:48:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1100, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:48:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1101, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:48:36', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1102, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:51:17', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1103, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:52:45', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1104, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:53:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1105, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:53:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1106, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:53:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1107, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:53:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1108, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:53:43', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1109, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:54:44', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1110, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 12:55:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1111, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 12:55:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1112, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 12:55:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1113, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 12:55:07', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1114, '申请已通过', '您申请的流程《请假流程变量测试666》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 12:55:42', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1115, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:29:17', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1116, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:35:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1117, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:35:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1118, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:35:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1119, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:35:40', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1120, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:36:17', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1121, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:36:55', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1122, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:37:04', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1123, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:37:04', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1124, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:37:04', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1125, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:37:04', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1126, '申请已通过', '您申请的流程《请假4444444444》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:38:36', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1127, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:39:35', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1128, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:40:14', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1129, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:40:14', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1130, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:40:14', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1131, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:40:14', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1132, '申请已通过', '您申请的流程《请假55555》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:41:43', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1133, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:42:23', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1134, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:42:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1135, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:42:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1136, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:42:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1137, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:42:49', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1138, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:45:29', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1139, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:46:05', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1140, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:46:23', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1141, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:46:23', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1142, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:46:23', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1143, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:46:23', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1144, '申请已通过', '您申请的流程《请假》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:46:38', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1145, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:48:15', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1146, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 15:48:30', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1147, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'nietingting', 'todo', '2024-06-09 15:48:30', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1148, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhangyunren', 'todo', '2024-06-09 15:48:30', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1149, '新的审批任务', '您有一条待处理的审批任务【人事专员】，请及时处理。', 'admin', 'zhouyafu', 'todo', '2024-06-09 15:48:30', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1150, '申请已通过', '您申请的流程《请假666》已通过', 'admin', 'liyuzhen', 'system', '2024-06-09 15:48:45', 0, 0, '/flow/instance', NULL);
INSERT INTO `sys_notify` VALUES (1151, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 18:22:05', 0, 0, '/flow/todo', NULL);
INSERT INTO `sys_notify` VALUES (1152, '新的审批任务', '您有一条待处理的审批任务【领导】，请及时处理。', 'admin', 'liyuzhen', 'todo', '2024-06-09 20:10:31', 0, 0, '/flow/todo', NULL);

-- ----------------------------
-- Table structure for sys_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_role`;
CREATE TABLE `sys_role`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `code` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '编号',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '名称',
  `data_scope` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '数据权限',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '描述',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1701429813977886722 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci COMMENT = '角色' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_role
-- ----------------------------
INSERT INTO `sys_role` VALUES (1357290971101491202, '管理员', '管理员', 0, '描述', 'admin', 'admin', '2021-02-04 19:32:39', '2024-05-22 22:27:49');
INSERT INTO `sys_role` VALUES (1357291099820486658, '普通用户', '普通用户', 1, '描述', 'admin', 'admin', '2021-02-04 19:33:10', '2024-05-09 21:15:47');
INSERT INTO `sys_role` VALUES (1357291137174958082, '超级管理员', '超级管理员', 0, '描述', 'admin', 'admin', '2021-02-04 19:33:19', '2024-05-09 21:15:53');
INSERT INTO `sys_role` VALUES (1568873508431171585, '项目经理', '项目经理', 1, '管理项目', 'admin', 'admin', '2022-09-11 16:06:07', '2023-08-30 12:16:15');
INSERT INTO `sys_role` VALUES (1568873622256193537, 'OA管理员', 'OA管理员', 1, '描述', 'admin', 'admin', '2022-09-11 16:06:34', '2024-03-31 23:25:27');
INSERT INTO `sys_role` VALUES (1607772303980032001, '游客', '游客', 0, '游客权限', 'admin', 'admin', '2022-12-28 00:16:03', '2023-10-16 17:22:11');
INSERT INTO `sys_role` VALUES (1701429262296887297, '产品经理', '产品经理', 1, NULL, 'admin', NULL, '2023-09-12 10:55:22', NULL);
INSERT INTO `sys_role` VALUES (1701429320358637570, 'CEO', 'CEO', 1, NULL, 'admin', NULL, '2023-09-12 10:55:36', NULL);
INSERT INTO `sys_role` VALUES (1701429410515202049, '客服经理', '客服经理', 1, NULL, 'admin', NULL, '2023-09-12 10:55:57', NULL);
INSERT INTO `sys_role` VALUES (1701429501409964034, '开发组长', '开发组长', 1, NULL, 'admin', NULL, '2023-09-12 10:56:19', NULL);
INSERT INTO `sys_role` VALUES (1701429689369309186, '网站管理员', '网站管理员', 1, NULL, 'admin', NULL, '2023-09-12 10:57:04', NULL);
INSERT INTO `sys_role` VALUES (1701429813977886721, '前端开发', '前端开发', 1, NULL, 'admin', NULL, '2023-09-12 10:57:33', NULL);

-- ----------------------------
-- Table structure for sys_role_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_role_menu`;
CREATE TABLE `sys_role_menu`  (
  `role_id` bigint UNSIGNED NOT NULL COMMENT '角色id',
  `menu_id` bigint UNSIGNED NOT NULL COMMENT ' 菜单id',
  PRIMARY KEY (`role_id`, `menu_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci COMMENT = '角色菜单' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_role_menu
-- ----------------------------
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1503734603045699586);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1504096722349985794);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691804508017930242);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691805323340296193);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691807004912267266);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691807701766516738);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691808141451210753);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691808471127699458);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691808842160025601);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691809070145613826);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691809238173626370);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691809637727219714);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691809827611750402);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1691809987955798018);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1692910220429234177);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1693455825024659457);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1693456041102618626);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695693169157025794);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695693439907737601);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695988578345627650);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695988781563850754);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695988916507193345);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989155200839682);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989229754593281);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989380925698050);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989447397027841);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989603978784770);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989665383395330);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989809222856705);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1695989885240422402);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1698578500009144321);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1704313720096239617);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1707618131277631489);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1707619093492912130);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1711931297412202497);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1713025685109346306);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1713026381678383105);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1713029617319677954);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1716830110782373884);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1716830110782373886);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1716830110782373889);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1719011859289968643);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1719011859289968644);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1719011859289968645);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1719011859289968646);
INSERT INTO `sys_role_menu` VALUES (1357290971101491202, 1719011859289968647);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1503734603045699586);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1504096722349985794);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691804508017930242);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691805323340296193);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691807004912267266);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691807701766516738);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691808141451210753);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691808471127699458);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691808842160025601);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691809070145613826);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691809238173626370);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691809637727219714);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691809827611750402);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1691809987955798018);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1692910220429234177);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1693455825024659457);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1693456041102618626);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1695693169157025794);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1695693439907737601);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1704313720096239617);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1707618131277631489);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1707619093492912130);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1711931297412202497);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1713025685109346306);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1713026381678383105);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1713029617319677954);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1716830110782373886);
INSERT INTO `sys_role_menu` VALUES (1357291099820486658, 1716830110782373889);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1503734603045699586);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1504096722349985794);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691804508017930242);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691805323340296193);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691807004912267266);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691807701766516738);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691808141451210753);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691808471127699458);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691808842160025601);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691809070145613826);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691809238173626370);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691809637727219714);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691809827611750402);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1691809987955798018);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1692910220429234177);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1693455825024659457);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1693456041102618626);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1695693169157025794);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1695693439907737601);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1707618131277631489);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1707619093492912130);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1711931297412202497);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1713025685109346306);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1713026381678383105);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1713029617319677954);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1716830110782373886);
INSERT INTO `sys_role_menu` VALUES (1357291137174958082, 1716830110782373889);
INSERT INTO `sys_role_menu` VALUES (1568873508431171585, 1695693439907737601);
INSERT INTO `sys_role_menu` VALUES (1568873508431171585, 1695989603978784770);
INSERT INTO `sys_role_menu` VALUES (1568873508431171585, 1695989665383395330);
INSERT INTO `sys_role_menu` VALUES (1568873622256193537, 1707619093492912130);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1503734603045699586);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1504096722349985794);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691804508017930242);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691805323340296193);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691807004912267266);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691807701766516738);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691808141451210753);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691808471127699458);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691808842160025601);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691809070145613826);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691809238173626370);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691809637727219714);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691809827611750402);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1691809987955798018);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1692910220429234177);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1693455825024659457);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1693456041102618626);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1695693169157025794);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1695693439907737601);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1698578500009144321);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1707618131277631489);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1707619093492912130);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1711931297412202497);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1713025685109346306);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1713026381678383105);
INSERT INTO `sys_role_menu` VALUES (1607772303980032001, 1713029617319677954);

-- ----------------------------
-- Table structure for sys_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_user`;
CREATE TABLE `sys_user`  (
  `id` bigint UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(15) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '姓名',
  `username` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '用户名',
  `password` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '密码',
  `avatar` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '头像',
  `sex` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '性别：0:未知，1:男，2:女',
  `phone` varchar(15) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '手机号',
  `email` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '邮箱',
  `enabled` bit(1) NOT NULL DEFAULT b'1' COMMENT '状态：0:禁用，1:启用',
  `dept_id` bigint UNSIGNED NULL DEFAULT NULL COMMENT '部门id',
  `leader` varchar(40) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '直属领导',
  `created_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '创建者',
  `updated_by` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NULL DEFAULT NULL COMMENT '更新者',
  `create_time` datetime NOT NULL COMMENT '创建日期',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1356976230017601552 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci COMMENT = '用户' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_user
-- ----------------------------
INSERT INTO `sys_user` VALUES (1, '系统管理员', 'admin', '$2a$10$ey5bu11ZvVwTfK9Yf6UYlezuiVhB5pasx0eDWcu4dIDv9cLC3/lc2', '/api/static/file/10118f6f-7e74-446e-95d2-1d1ea4a1dad6OIP-C (4).jpg', 2, '15606613352', '1941338475@qq.com', b'1', 1357882876154490881, 'caiyan', 'admin', 'admin', '2024-03-03 10:53:39', '2024-05-27 15:44:04');
INSERT INTO `sys_user` VALUES (2, '测试01', 'test01', '$2a$10$DFaPdLMWLJ.lL0OdzNyopuapUwmSJpN5ETOqkeq5HQsrzl8OIpdDO', '/api/static/file/f8d1c200-1a41-40f4-89fb-8739f683918cavatar.png', 2, '15606613352', '1941338475@qq.com', b'1', 1357882876154490881, NULL, 'admin', 'admin', '2024-03-03 10:53:39', '2024-05-27 15:44:08');
INSERT INTO `sys_user` VALUES (3, '系统', '00000', '$2a$10$ey5bu11ZvVwTfK9Yf6UYlezuiVhB5pasx0eDWcu4dIDv9cLC3/lc2', '/api/static/file/10118f6f-7e74-446e-95d2-1d1ea4a1dad6OIP-C (4).jpg', 2, '15606613352', '1941338475@qq.com', b'1', 1357882876154490881, NULL, 'admin', 'admin', '2024-03-03 10:53:39', '2024-05-27 15:44:12');
INSERT INTO `sys_user` VALUES (1356976230017601539, '李玉珍', 'liyuzhen', '$2a$10$zMbUx27SLv9nWhTsicKuFO6/SlmUZQ/h5jUbScO0Axpx6oTedv8wG', '/api/static/file/e6e4dd5b-e3a9-4ade-9436-7538549adf4bOIP-C.jpg', 2, '15606613333', '1941338475@qq.com', b'1', 1538426198781095937, NULL, 'admin', 'admin', '2024-03-31 23:47:19', '2024-05-27 15:44:18');
INSERT INTO `sys_user` VALUES (1356976230017601540, '张云任', 'zhangyunren', '$2a$10$yhLsGQsNFJFnnBel8WIGPeeMbVNi8GD9wgYcVroi2002WC6rXwkdW', '/api/static/file/e90ad53c-df7e-4ea9-a73f-41bdc927945eQRqMK.jpg', 1, '15606613334', '1941338475@qq.com', b'1', 1538427176800514050, NULL, 'admin', 'admin', '2024-03-31 23:48:13', '2024-05-27 15:44:27');
INSERT INTO `sys_user` VALUES (1356976230017601541, '周亚夫', 'zhouyafu', '$2a$10$DFaPdLMWLJ.lL0OdzNyopuapUwmSJpN5ETOqkeq5HQsrzl8OIpdDO', '/api/static/file/f7a8259f-9e81-4d0c-853d-5e430e2a1bf2QR57a.jpg', 1, '15606613395', '1941338475@qq.com', b'1', 1538426900681093121, NULL, 'admin', 'admin', '2024-04-01 10:47:28', '2024-05-27 15:44:30');
INSERT INTO `sys_user` VALUES (1356976230017601542, '邓真', 'dengzhen', '$2a$10$lIJxVimQijOAjM9AJjKm0OMqMD3hhJ22Tukp1Mh7.pPYPQiH8gd9y', '/api/static/file/997a5a07-77be-47e8-b506-cdafea147694QRBHS.jpg', 1, '15606613396', '1941338475@qq.com', b'1', 1538426900681093121, NULL, 'admin', 'admin', '2024-04-01 10:49:54', '2024-05-27 15:44:36');
INSERT INTO `sys_user` VALUES (1356976230017601543, '杨映秋', 'yangyingqiu', '$2a$10$Wbr.ujXWKRM6dKvIen22mO.gzGOKbA3.KGhJBRDrLCXDQcpWLvbv6', '/api/static/file/4e118a9a-82e4-4920-94d6-818122043ff0OIP-C (7).jpg', 1, '15606613396', '15606613396@qq.com', b'1', 1357882410670682114, NULL, 'admin', NULL, '2024-04-01 10:51:25', NULL);
INSERT INTO `sys_user` VALUES (1356976230017601544, '聂婷婷', 'nietingting', '$2a$10$AboKkPB42dYwdV0e0Kdr9evNMMm93bQiJiyGIlKN617ZtrWZKWnCq', '/api/static/file/c7bd8506-bbd6-4b94-bbff-b8733db09c89OIP-C (2).jpg', 2, '15606613397', '1941338475@qq.com', b'1', 1538427031631458306, NULL, 'admin', 'admin', '2024-04-01 10:52:46', '2024-05-27 15:44:41');
INSERT INTO `sys_user` VALUES (1356976230017601545, '吴明杰', 'wumingjie', '$2a$10$77WDAs2Lo4ecq5kDzfoVTuxOF0tfC3a/gGbkHE68B.Mo4Tg5VmqZ2', '/api/static/file/36311595-5ce0-4a5b-8f7b-f64d37072e0bOIP-C (1).jpg', 1, '15606613319', '1941338475@qq.com', b'1', 1357882876154490882, NULL, 'admin', 'admin', '2024-04-01 10:54:11', '2024-05-27 15:44:45');
INSERT INTO `sys_user` VALUES (1356976230017601546, '沈翰林', 'shenhanlin', '$2a$10$lyfX6CyhGuLNlFzZ8A2dpOxKrP9IABExM2Hapcw/BgFgjCaIxw2kK', '/api/static/file/38959647-e230-48c6-b3d0-fa31c94c18bd下载.jpg', 1, '15606613318', '1941338475@qq.com', b'1', 1538426930959773697, NULL, 'admin', 'admin', '2024-04-01 10:55:09', '2024-05-27 15:44:53');
INSERT INTO `sys_user` VALUES (1356976230017601547, '吴飞鸿', 'wufeihong', '$2a$10$mS0UPMfgdV6hfMo5HXsiKe4LG8yK7hlxMRFB0dzsztj95p65OfEHy', '/api/static/file/1e52370d-fed0-4fa1-a03a-f82a2a93358fOIP-C (3).jpg', 1, '15606613390', '1941338475@qq.com', b'1', 1538426269257986049, NULL, 'admin', 'admin', '2024-04-01 10:56:27', '2024-05-27 15:44:57');
INSERT INTO `sys_user` VALUES (1356976230017601548, '郑菲', 'zhengfei', '$2a$10$geVy0HA8jUHTSvTlVIRzx.zRPFgwfF7uQLucIsLv7ZOnwaG5gDoym', '/api/static/file/9010f7f6-d9cc-418d-bc2b-1ecaa3dd37f7OIP-C (4).jpg', 2, '15606613361', '1941338475@qq.com', b'1', 1538426719302610945, NULL, 'admin', 'admin', '2024-04-01 10:57:28', '2024-05-27 15:45:01');
INSERT INTO `sys_user` VALUES (1356976230017601549, '蔡艳', 'caiyan', '$2a$10$fxOOaa/jxjkfKftk5WZ34.Rih9wBWriiuliak7o4QF4BeZ.5dCXHW', '/api/static/file/778c2c9d-f8f5-40db-a6c9-04874bc7447b201962717313730705.jpeg', 2, '15606613387', '1941338475@qq.com', b'1', 1538426048373354498, 'zhangyunren', 'admin', 'admin', '2024-04-01 10:59:21', '2024-05-27 15:45:04');
INSERT INTO `sys_user` VALUES (1356976230017601550, '姚彤', 'yaotong', '$2a$10$dxS/DMpB4n/D58a6cMbKdODyhWVVRqPY7vjeUP0vsJrUxfUGXIFo2', '/api/static/file/5be7bff8-7d3f-4c15-9255-7dc7d24db2b7OIP-C (5).jpg', 2, '15606613354', '1941338475@qq.com', b'1', 1538426418701037570, NULL, 'admin', 'admin', '2024-04-01 11:00:15', '2024-05-27 15:45:08');
INSERT INTO `sys_user` VALUES (1356976230017601551, '马涛', 'matao', '$2a$10$CaAdJumgRz4dO6d6JKyr.OkXLhquUnBmnefNAFbPWsZ7UdnxJOHDq', '/api/static/file/15264081-a8e1-4f97-8e45-7382bc5eadc1OIP-C (6).jpg', 1, '15606613386', '1941338475@qq.com', b'1', 1538426509662908418, NULL, 'admin', 'admin', '2024-04-01 11:01:32', '2024-05-27 15:45:11');

-- ----------------------------
-- Table structure for sys_user_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_user_role`;
CREATE TABLE `sys_user_role`  (
  `user_id` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '用户id',
  `role_id` bigint NOT NULL COMMENT '角色id',
  PRIMARY KEY (`user_id`, `role_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_0900_ai_ci COMMENT = '用户角色' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of sys_user_role
-- ----------------------------
INSERT INTO `sys_user_role` VALUES ('caiyan', 1357290971101491202);
INSERT INTO `sys_user_role` VALUES ('liyuzhen', 1357290971101491202);
INSERT INTO `sys_user_role` VALUES ('liyuzhen', 1357291099820486658);
INSERT INTO `sys_user_role` VALUES ('test01', 1357290971101491202);

SET FOREIGN_KEY_CHECKS = 1;
